<?php

namespace App\Services\Data;

use App\Models\JuxingAdAccount;
use App\Models\JxQtaskVideoOrderList;
use App\Models\JxStarVideoFlowOrderHourData;
use App\Models\JxStarVideoOrderList;
use App\Models\JxQtaskLiveOrderList;
use App\Models\JxStarLiveOrderList;
use App\Models\JxQtaskVideoFlowOrderList;
use App\Models\JxStarVideoFlowOrderList;
use App\Models\JxStarLiveFlowOrderList;
use App\Models\JxCostDailyData;
use App\Models\JxStarVideoFlowOrderDailyData;
use App\Models\JxStarUsers;
use App\Models\JxQtaskVideoOrderDaily;
use App\Models\JxQtaskLiveOrderDaily;
use App\Models\JxStarVideoTaskList;
use App\Models\Sys\SysCustomer;
use App\Models\Sys\SysCustomerAdver;
use App\Models\Sys\SysIndustry;
use Illuminate\Support\Facades\Auth;

use App\Support\RedisModel;

class DataStatService
{
	protected static $videoRankKey_ = 'StarVideoRankDatas-';
	protected static $liveRankKey_ = 'StarLiveRankDatas-';

	public static function redVideoRank($day, $column, $flag, $page, $pageSize)
	{
		if($day == 180){
			$day = 90; //暂时只统计90天数据
		}
		$rkey = self::$videoRankKey_  . $flag . '-' . $column . '-' . $day;
		$data = RedisModel::get($rkey);

		if( !empty($data) ){
			$data = json_decode($data, true);

			$total = count($data);
			$offset = ($page-1) * $pageSize;
			$data = array_slice($data, $offset, $pageSize);

			foreach($data as $k=>&$v){
				$v['rank'] = $offset+$k+1;
				$v['amount'] = round($v['amount']/1000, 2);
				$v['cpm'] = round($v['cpm']/1000, 2);
				$v['cpc'] = round($v['cpc']/1000, 2);
				$v['cpa'] = round($v['cpa']/1000, 2);

				$v['click_rate'] = $v['click_rate']>0 ? $v['click_rate']*100 : 0;
				$v['play_5s_rate'] = $v['play_5s_rate']>0 ? $v['play_5s_rate']*100 : 0;
				$v['play_end_rate'] = $v['play_end_rate']>0 ? $v['play_end_rate']*100 : 0;
				$v['item_click_rate'] = $v['item_click_rate']>0 ? $v['item_click_rate']*100 : 0;
			}

			return [$data, $total];
		} else {
			return [null, 0];
		}
	}

	public static function redLiveRank($day, $column, $flag, $page, $pageSize)
	{
		if($day == 180){
			$day = 90; //暂时只统计90天数据
		}
		$rkey = self::$liveRankKey_  . $flag . '-' . $column . '-' . $day;
		$data = RedisModel::get($rkey);

		if( !empty($data) ){
			$data = json_decode($data, true);

			$total = count($data);
			$offset = ($page-1) * $pageSize;
			$data = array_slice($data, $offset, $pageSize);

			foreach($data as $k=>&$v){
				$v['rank'] = $offset+$k+1;
				$v['amount'] = round($v['amount']/1000, 2);
				$v['cpm'] = round($v['cpm']/1000, 2);
				//$v['item_cpc'] = round($v['item_cpc']/1000, 2);
				$v['cpa'] = round($v['cpa']/1000, 2);

				$v['item_click_rate'] = $v['item_click_rate']>0 ? $v['item_click_rate']*100 : 0;
			}

			return [$data, $total];
		} else {
			return [null, 0];
		}
	}

	#总消耗
	public static function costDataTotal($st_date, $en_date)
	{
		#星视频
		$starVideo = JxStarVideoOrderList::selectRaw('sum(real_amount) as cost')
			->where('star_release_time', '>=', $st_date)
			->where('star_release_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->first();
        $starVideoCost = $starVideo->cost ?? 0;

		#星直播
		$starLive = JxStarLiveOrderList::selectRaw('sum(real_amount) as cost')
			->where('live_start_time', '>=', $st_date)
			->where('live_start_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->first();
        $starLiveCost = $starLive->cost ?? 0;

		#星任务
		$qTaskVideo = JxQtaskVideoOrderList::selectRaw('sum(amount) as cost')
			->where('star_release_time', '>=', $st_date)
			->where('star_release_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->first();
        $qTaskVideoCost = $qTaskVideo->cost ?? 0;

		$qTaskLive = JxQtaskLiveOrderList::selectRaw('sum(amount) as cost')
			->where('star_release_time', '>=', $st_date)
			->where('star_release_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->first();
        $qTaskLiveCost = $qTaskLive->cost ?? 0;

		#流量助推
		$flowQtaskVideo = JxQtaskVideoFlowOrderList::selectRaw('sum(consume_amount) as cost')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->first();
        $flowQtaskVideoCost = $flowQtaskVideo->cost ?? 0;

		$flowStarVideo = JxStarVideoFlowOrderList::selectRaw('sum(consume_amount) as cost')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->first();
        $flowStarVideoCost = $flowStarVideo->cost ?? 0;

		$flowStarLive = JxStarLiveFlowOrderList::selectRaw('sum(consume_amount) as cost')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->first();
        $flowStarLiveCost = $flowStarLive->cost ?? 0;

        $starVideoCost = round($starVideoCost/1000, 2);
        $starLiveCost = round($starLiveCost/1000, 2);
        $qTaskCost = round($qTaskVideoCost/1000, 2) + round($qTaskLiveCost/1000, 2);
        $flowCost = round($flowQtaskVideoCost/1000, 2) + round($flowStarVideoCost/1000, 2) + round($flowStarLiveCost/1000, 2);

        #总消耗
        $totalCost = round($starVideoCost
        	+ $starLiveCost
        	+ $qTaskCost
        	+ $flowCost, 2);

        return [
        	'totalCost' => $totalCost,
        	'starVideoCost' => $starVideoCost,
        	'starLiveCost' => $starLiveCost,
        	'qTaskCost' => $qTaskCost,
        	'flowCost' => $flowCost,
        ];
	}

	#分客户消耗
	public static function custCostList($st_date, $en_date, $sort='totalCost', $sort_type=0)
	{
		#查客户信息
		$custList = SysCustomer::select('id', 'name', 'industry_id')->where('enable', 1)->get()->keyBy('id')->toArray();

		$_costs = [
        	'totalCost' => 0,
        	'starVideoCost' => 0,
        	'starLiveCost' => 0,
        	'qTaskCost' => 0,
        	'flowCost' => 0
        ];

        foreach($custList as &$val){
        	$val = array_merge($val, $_costs);
        }

		#查客户广告主关系
		$advers = SysCustomerAdver::select('customer_id', 'advertiser_id')->where('enable', 1)->get()->keyBy('advertiser_id')->toArray();

		#星视频
		$starVideo = JxStarVideoOrderList::selectRaw('sum(real_amount) as cost, advertiser_id')
			->where('star_release_time', '>=', $st_date)
			->where('star_release_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();
        if(!empty($starVideo)){
        	self::custCostDivide('starVideoCost', $starVideo, $advers, $custList);
        }

		#星直播
		$starLive = JxStarLiveOrderList::selectRaw('sum(real_amount) as cost, advertiser_id')
			->where('live_start_time', '>=', $st_date)
			->where('live_start_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();
        if(!empty($starLive)){
        	self::custCostDivide('starLiveCost', $starLive, $advers, $custList);
        }

		#星任务
		$qTaskVideo = JxQtaskVideoOrderList::selectRaw('sum(amount) as cost, advertiser_id')
			->where('star_release_time', '>=', $st_date)
			->where('star_release_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();
        if(!empty($qTaskVideo)){
        	self::custCostDivide('qTaskCost', $qTaskVideo, $advers, $custList);
        }

		$qTaskLive = JxQtaskLiveOrderList::selectRaw('sum(amount) as cost, advertiser_id')
			->where('star_release_time', '>=', $st_date)
			->where('star_release_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();
        if(!empty($qTaskLive)){
        	self::custCostDivide('qTaskCost', $qTaskLive, $advers, $custList);
        }

		#流量助推
		$flowQtaskVideo = JxQtaskVideoFlowOrderList::selectRaw('sum(consume_amount) as cost, advertiser_id')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();
        if(!empty($flowQtaskVideo)){
        	self::custCostDivide('flowCost', $flowQtaskVideo, $advers, $custList);
        }

		$flowStarVideo = JxStarVideoFlowOrderList::selectRaw('sum(consume_amount) as cost, advertiser_id')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();
        if(!empty($flowStarVideo)){
        	self::custCostDivide('flowCost', $flowStarVideo, $advers, $custList);
        }

		$flowStarLive = JxStarLiveFlowOrderList::selectRaw('sum(consume_amount) as cost, advertiser_id')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();
        if(!empty($flowStarLive)){
        	self::custCostDivide('flowCost', $flowStarLive, $advers, $custList);
        }

        $custList = array_values($custList);

        if($sort_type){
        	array_multisort(array_column($custList, $sort), SORT_ASC, $custList);
        } else {
        	array_multisort(array_column($custList, $sort), SORT_DESC, $custList);
        }

        return $custList;
	}

	public static function custCostDivide($typeCost, $dataList, $advers, &$custList)
	{
		foreach($dataList as $item){
			$adver_id = $item->advertiser_id;
			$cost = $item->cost/1000;

			$cu_id = $advers[$adver_id]['customer_id'] ?? null;
			if( !$cu_id ){
				continue;
			}

			if( !isset($custList[$cu_id]) ){
				continue;
			}

			$custList[$cu_id][$typeCost] = round($custList[$cu_id][$typeCost]+$cost, 2);
			$custList[$cu_id]['totalCost'] = round($custList[$cu_id]['totalCost']+$cost, 2);
		}

		return ;
	}

	public static function custFlowVideoList($st_date, $en_date, $sort, $sort_type, $page, $pageSize)
	{
		#查客户信息
		$userInfo = Auth::user();
		$custList = SysCustomer::select('id', 'name', 'industry_id')->whereIn('id', $userInfo->custIds)->where('enable', 1)->get()->keyBy('id')->toArray();

		$_cols = [
        	'consume_amount' => 0,
        	'play' => 0,
        	'action' => 0,         //行为数
        	'conversion' => 0,     //激活数
        	'comment' => 0,
        	'admire' => 0,
        	'played3s_cnt' => 0,
        	'played3s_percent' => 0,
        	'ctr' => 0,  //行为率
        	'cpm' => 0,  //千次播放成本
        	'cpc' => 0,  //点击成本
        	'cpa' => 0  //激活成本
        ];

        foreach($custList as &$val){
        	$val = array_merge($val, $_cols);
        }

		#查客户广告主关系
		$advers = SysCustomerAdver::select('customer_id', 'advertiser_id')->where('enable', 1)->get()->keyBy('advertiser_id')->toArray();

		#流量助推
		$flowQtaskVideo = JxQtaskVideoFlowOrderList::selectRaw('
				advertiser_id,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();
        if(!empty($flowQtaskVideo)){
        	self::custFlowVideoDivide($flowQtaskVideo, $advers, $custList);
        }

		$flowStarVideo = JxStarVideoFlowOrderList::selectRaw('
				advertiser_id,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();
        if(!empty($flowStarVideo)){
        	self::custFlowVideoDivide($flowStarVideo, $advers, $custList);
        }

        foreach($custList as &$val){
        	#计算值补充
        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
        	$val['played3s_percent'] = $val['play']>0 ? round($val['played3s_cnt']/$val['play']*100, 2) : 0;
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['consume_amount']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['consume_amount']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['consume_amount']/$val['conversion'], 2) : null;
        }

        if($sort_type){
        	array_multisort(array_column($custList, $sort), SORT_ASC, $custList);
        } else {
        	array_multisort(array_column($custList, $sort), SORT_DESC, $custList);
        }

        $offset = ($page-1) * $pageSize;
        $total = count($custList);
        $custList = array_slice($custList, $offset, $pageSize);

        return [$custList, $total];
	}


	public static function custFlowVideoDivide($dataList, $advers, &$custList)
	{
		$columns = [
			'consume_amount',
        	'play',
        	'action',         //行为数
        	'conversion',     //激活数
        	'comment',
        	'admire',
        	'played3s_cnt'
		];

		foreach($dataList as $item){

			$adver_id = $item->advertiser_id;

			$cu_id = $advers[$adver_id]['customer_id'] ?? null;
			if( !$cu_id ){
				continue;
			}

			if( !isset($custList[$cu_id]) ){
				continue;
			}

			foreach($columns as $column){
				$custList[$cu_id][$column] += $item->$column;
			}

		}

		return ;
	}

	/**
	 * 获取流量助推视频-客户分日数据详情
	 */
	public static function custFlowVideoDetails($st_date, $en_date, $cust_id, $page, $pageSize)
	{
		#获取广告主ids
		$adver_ids = SysCustomerAdver::where('enable', 1)->where('customer_id', $cust_id)->pluck('advertiser_id')->all();

		$dates = array();
		$th_date = $en_date;
		while($th_date>=$st_date){

			$dates[$th_date] = null;
			$th_date = date('Y-m-d', strtotime($th_date)-86400);
		}

		#流量助推
		$flowQtaskVideo = JxQtaskVideoFlowOrderList::selectRaw('
				left(promotion_begin_time, 10) as idate,
				count(distinct(user_id)) as user_count,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('idate')
            ->get()
            ->keyBy('idate')
            ->toArray();

		$flowStarVideo = JxStarVideoFlowOrderList::selectRaw('
				left(promotion_begin_time, 10) as idate,
				count(distinct(user_id)) as user_count,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('idate')
            ->get()
            ->keyBy('idate')
            ->toArray();

        if(!empty($flowQtaskVideo) || !empty($flowStarVideo)){
        	foreach($dates as $d => &$val){
        		if( isset($flowQtaskVideo[$d]) ){
        			$val = $flowQtaskVideo[$d];

        			if( isset($flowStarVideo[$d]) ){
        				$val['user_count'] += $flowStarVideo[$d]['user_count'];
        				$val['consume_amount'] += $flowStarVideo[$d]['consume_amount'];
        				$val['play'] += $flowStarVideo[$d]['play'];
        				$val['action'] += $flowStarVideo[$d]['action'];
        				$val['conversion'] += $flowStarVideo[$d]['conversion'];
        				$val['comment'] += $flowStarVideo[$d]['comment'];
        				$val['admire'] += $flowStarVideo[$d]['admire'];
        				$val['played3s_cnt'] += $flowStarVideo[$d]['played3s_cnt'];
        			}
        		} elseif (isset($flowStarVideo[$d])){
        			$val = $flowStarVideo[$d];
        		}

        		if(!empty($val)){
        			#计算值补充
		        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
		        	$val['played3s_percent'] = $val['play']>0 ? round($val['played3s_cnt']/$val['play']*100, 2) : 0;
		        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
		        	$val['cpm'] = $val['play']>0 ? round($val['consume_amount']/$val['play']*1000, 2) : null;
		        	$val['cpc'] = $val['action']>0 ? round($val['consume_amount']/$val['action'], 2) : null;
		        	$val['cpa'] = $val['conversion']>0 ? round($val['consume_amount']/$val['conversion'], 2) : null;
        		}
        	}
        }

        $dates = array_values(array_filter($dates));

        $offset = ($page-1) * $pageSize;
        $total = count($dates);
        $dates = array_slice($dates, $offset, $pageSize);

        return [$dates, $total];
	}

	public static function custFlowVideoUserDetails($date, $cust_id)
	{
		#获取广告主ids
		$adver_ids = SysCustomerAdver::where('enable', 1)->where('customer_id', $cust_id)->pluck('advertiser_id')->all();

		$flowQtaskVideo = JxQtaskVideoFlowOrderList::selectRaw('
				user_id,
				any_value(star_name) as star_name,
				any_value(kwai_id) as kwai_id,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $date)
			->where('promotion_begin_time', '<=', $date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('user_id')
            ->get()
            ->toArray();

		$flowStarVideo = JxStarVideoFlowOrderList::selectRaw('
				user_id,
				any_value(star_name) as star_name,
				any_value(kwai_id) as kwai_id,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $date)
			->where('promotion_begin_time', '<=', $date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('user_id')
            ->get()
            ->toArray();

        foreach($flowQtaskVideo as &$val){
        	$val['idate'] = $date;
        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
        	$val['played3s_percent'] = $val['play']>0 ? round($val['played3s_cnt']/$val['play']*100, 2) : 0;
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['consume_amount']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['consume_amount']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['consume_amount']/$val['conversion'], 2) : null;
        }

        foreach($flowStarVideo as &$val){
        	$val['idate'] = $date;
        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
        	$val['played3s_percent'] = $val['play']>0 ? round($val['played3s_cnt']/$val['play']*100, 2) : 0;
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['consume_amount']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['consume_amount']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['consume_amount']/$val['conversion'], 2) : null;
        }

        return array_merge($flowQtaskVideo, $flowStarVideo);
	}

	public static function custFlowLiveList($st_date, $en_date, $sort, $sort_type, $page, $pageSize)
	{
		#查客户信息
		$userInfo = Auth::user();
		$custList = SysCustomer::select('id', 'name', 'industry_id')->whereIn('id', $userInfo->custIds)->where('enable', 1)->get()->keyBy('id')->toArray();

		$_cols = [
        	'consume_amount' => 0,
        	'audience_num' => 0,   //引入观众数
        	'played3s_num' => 0,    //观看3秒+观众数
        	'fans_increase_num' => 0,  //涨粉数
        	'item_impression_num' => 0,  //推广直播间曝光数
        	'interactive_num' => 0,      //互动数
        	'conversion_impression_num' => 0, //组件曝光数
        	'conversion_action_num' => 0,   //行为数
        	'cash_amount' => 0,
        	'client_amount' => 0,
        	'agency_amount' => 0,
        	'credit_consume_amount' => 0,

        	'ctr' => 0,  //行为率
        	//'cpm' => 0,  //千次播放成本
        	//'cpc' => 0,  //点击成本
        	'cpa' => 0  //激活成本
        ];

        foreach($custList as &$val){
        	$val = array_merge($val, $_cols);
        }

		#查客户广告主关系
		$advers = SysCustomerAdver::select('customer_id', 'advertiser_id')->where('enable', 1)->get()->keyBy('advertiser_id')->toArray();

		#流量助推
		$flowStarLive = JxStarLiveFlowOrderList::selectRaw('
				advertiser_id,
				sum(consume_amount) as consume_amount,
				sum(audience_num) as audience_num,
				sum(played3s_num) as played3s_num,
				sum(fans_increase_num) as fans_increase_num,
				sum(item_impression_num) as item_impression_num,
				sum(interactive_num) as interactive_num,
				sum(conversion_impression_num) as conversion_impression_num,
				sum(conversion_action_num) as conversion_action_num,
				sum(cash_amount) as cash_amount,
				sum(client_amount) as client_amount,
				sum(agency_amount) as agency_amount,
				sum(credit_consume_amount) as credit_consume_amount
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();

        if(!empty($flowStarLive)){
        	self::custFlowLiveDivide($flowStarLive, $advers, $custList);
        }

        foreach($custList as &$val){
        	#计算值补充
        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
        	$val['cash_amount'] = round($val['cash_amount']/1000, 2);
        	$val['client_amount'] = round($val['client_amount']/1000, 2);
        	$val['agency_amount'] = round($val['agency_amount']/1000, 2);
        	$val['credit_consume_amount'] = round($val['credit_consume_amount']/1000, 2);

        	$val['ctr'] = $val['conversion_impression_num']>0 ? round($val['conversion_action_num']/$val['conversion_impression_num']*100, 2) : 0;
        	//$val['cpm'] = $val['play']>0 ? round($val['consume_amount']/$val['play']*1000, 2) : null;
        	//$val['cpc'] = $val['action']>0 ? round($val['consume_amount']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion_action_num']>0 ? round($val['consume_amount']/$val['conversion_action_num'], 2) : null;
        }

        if($sort_type){
        	array_multisort(array_column($custList, $sort), SORT_ASC, $custList);
        } else {
        	array_multisort(array_column($custList, $sort), SORT_DESC, $custList);
        }

        $offset = ($page-1) * $pageSize;
        $total = count($custList);
        $custList = array_slice($custList, $offset, $pageSize);

        return [$custList, $total];
	}

	public static function custFlowLiveDivide($dataList, $advers, &$custList)
	{
		$columns = [
			'consume_amount',
        	'audience_num',   //引入观众数
        	'played3s_num',    //观看3秒+观众数
        	'fans_increase_num',  //涨粉数
        	'item_impression_num',  //推广直播间曝光数
        	'interactive_num',      //互动数
        	'conversion_impression_num', //组件曝光数
        	'conversion_action_num',   //行为数
        	'cash_amount',
        	'client_amount',
        	'agency_amount',
        	'credit_consume_amount'
		];

		foreach($dataList as $item){

			$adver_id = $item->advertiser_id;

			$cu_id = $advers[$adver_id]['customer_id'] ?? null;
			if( !$cu_id ){
				continue;
			}

			if( !isset($custList[$cu_id]) ){
				continue;
			}

			foreach($columns as $column){
				$custList[$cu_id][$column] += $item->$column;
			}
		}

		return ;
	}

	public static function custFlowLiveDetails($st_date, $en_date, $cust_id, $page, $pageSize)
	{
		#获取广告主ids
		$adver_ids = SysCustomerAdver::where('enable', 1)->where('customer_id', $cust_id)->pluck('advertiser_id')->all();

		$dates = array();
		$th_date = $en_date;
		while($th_date>=$st_date){

			$dates[$th_date] = null;
			$th_date = date('Y-m-d', strtotime($th_date)-86400);
		}

		#流量助推
		$flowStarLive = JxStarLiveFlowOrderList::selectRaw('
				left(promotion_begin_time, 10) as idate,
				count(distinct(user_id)) as user_count,
				sum(consume_amount) as consume_amount,
				sum(audience_num) as audience_num,
				sum(played3s_num) as played3s_num,
				sum(fans_increase_num) as fans_increase_num,
				sum(item_impression_num) as item_impression_num,
				sum(interactive_num) as interactive_num,
				sum(conversion_impression_num) as conversion_impression_num,
				sum(conversion_action_num) as conversion_action_num,
				sum(cash_amount) as cash_amount,
				sum(client_amount) as client_amount,
				sum(agency_amount) as agency_amount,
				sum(credit_consume_amount) as credit_consume_amount
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('idate')
            ->get()
            ->keyBy('idate')
            ->toArray();


        if(!empty($flowStarLive) ){
        	foreach($dates as $d => &$val){
        		if( isset($flowStarLive[$d]) ){
        			$val = $flowStarLive[$d];

     				$val['consume_amount'] = round($val['consume_amount']/1000, 2);
		        	$val['cash_amount'] = round($val['cash_amount']/1000, 2);
		        	$val['client_amount'] = round($val['client_amount']/1000, 2);
		        	$val['agency_amount'] = round($val['agency_amount']/1000, 2);
		        	$val['credit_consume_amount'] = round($val['credit_consume_amount']/1000, 2);

		        	$val['ctr'] = $val['conversion_impression_num']>0 ? round($val['conversion_action_num']/$val['conversion_impression_num']*100, 2) : 0;
		        	$val['cpa'] = $val['conversion_action_num']>0 ? round($val['consume_amount']/$val['conversion_action_num'], 2) : null;
        		}

        	}
        }

        $dates = array_values(array_filter($dates));

        $offset = ($page-1) * $pageSize;
        $total = count($dates);
        $dates = array_slice($dates, $offset, $pageSize);

        return [$dates, $total];
	}

	public static function custFlowLiveUserDetails($date, $cust_id)
	{
		#获取广告主ids
		$adver_ids = SysCustomerAdver::where('enable', 1)->where('customer_id', $cust_id)->pluck('advertiser_id')->all();

		$flowStarLive = JxStarLiveFlowOrderList::selectRaw('
				user_id,
				any_value(star_name) as star_name,
				any_value(kwai_id) as kwai_id,
				sum(consume_amount) as consume_amount,
				sum(audience_num) as audience_num,
				sum(played3s_num) as played3s_num,
				sum(fans_increase_num) as fans_increase_num,
				sum(item_impression_num) as item_impression_num,
				sum(interactive_num) as interactive_num,
				sum(conversion_impression_num) as conversion_impression_num,
				sum(conversion_action_num) as conversion_action_num,
				sum(cash_amount) as cash_amount,
				sum(client_amount) as client_amount,
				sum(agency_amount) as agency_amount,
				sum(credit_consume_amount) as credit_consume_amount
			')
			->where('promotion_begin_time', '>=', $date)
			->where('promotion_begin_time', '<=', $date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('user_id')
            ->get()
            ->toArray();

        foreach($flowStarLive as &$val){
        	$val['idate'] = $date;

        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
        	$val['cash_amount'] = round($val['cash_amount']/1000, 2);
        	$val['client_amount'] = round($val['client_amount']/1000, 2);
        	$val['agency_amount'] = round($val['agency_amount']/1000, 2);
        	$val['credit_consume_amount'] = round($val['credit_consume_amount']/1000, 2);

        	$val['ctr'] = $val['conversion_impression_num']>0 ? round($val['conversion_action_num']/$val['conversion_impression_num']*100, 2) : 0;
        	$val['cpa'] = $val['conversion_action_num']>0 ? round($val['consume_amount']/$val['conversion_action_num'], 2) : null;
        }

        return $flowStarLive;
	}


	public static function industryFlowVideoList($st_date, $en_date, $sort, $sort_type, $page, $pageSize)
	{
		#查客户信息
		$userInfo = Auth::user();
		$custIndustryIds = SysCustomer::where('enable', 1)->whereIn('id', $userInfo->custIds)->pluck('industry_id', 'id')->all();

		#行业信息
		$industrys = SysIndustry::whereIn('industry_id', $custIndustryIds)->select('industry_name', 'industry_id')->get()->keyBy('industry_id')->toArray();

		$_cols = [
        	'consume_amount' => 0,
        	'play' => 0,
        	'action' => 0,         //行为数
        	'conversion' => 0,     //激活数
        	'comment' => 0,
        	'admire' => 0,
        	'played3s_cnt' => 0,
        	'played3s_percent' => 0,
        	'ctr' => 0,  //行为率
        	'cpm' => 0,  //千次播放成本
        	'cpc' => 0,  //点击成本
        	'cpa' => 0  //激活成本
        ];

        foreach($industrys as &$val){
        	$val = array_merge($val, $_cols);
        }

		#查客户广告主关系
		$advers = SysCustomerAdver::select('customer_id', 'advertiser_id')->where('enable', 1)->get()->keyBy('advertiser_id')->toArray();
		$adverIndustrys = array();
		foreach($advers as $adver_id=>$v){
			$cu_id = $v['customer_id'];

			$industry_id = $custIndustryIds[$cu_id] ?? null;
			if($industry_id){
				$adverIndustrys[$adver_id] = $industry_id;
			}
		}

		#流量助推
		$flowQtaskVideo = JxQtaskVideoFlowOrderList::selectRaw('
				advertiser_id,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();
        if(!empty($flowQtaskVideo)){
        	self::industryFlowVideoDivide($flowQtaskVideo, $adverIndustrys, $industrys);
        }

		$flowStarVideo = JxStarVideoFlowOrderList::selectRaw('
				advertiser_id,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();
        if(!empty($flowStarVideo)){
        	self::industryFlowVideoDivide($flowStarVideo, $adverIndustrys, $industrys);;
        }

        foreach($industrys as &$val){
        	#计算值补充
        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
        	$val['played3s_percent'] = $val['play']>0 ? round($val['played3s_cnt']/$val['play']*100, 2) : 0;
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['consume_amount']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['consume_amount']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['consume_amount']/$val['conversion'], 2) : null;
        }

        if($sort_type){
        	array_multisort(array_column($industrys, $sort), SORT_ASC, $industrys);
        } else {
        	array_multisort(array_column($industrys, $sort), SORT_DESC, $industrys);
        }

        $offset = ($page-1) * $pageSize;
        $total = count($industrys);
        $industrys = array_slice($industrys, $offset, $pageSize);

        return [$industrys, $total];
	}

	public static function industryFlowVideoDivide($dataList, $adverIndustrys, &$industrys)
	{
		$columns = [
			'consume_amount',
        	'play',
        	'action',         //行为数
        	'conversion',     //激活数
        	'comment',
        	'admire',
        	'played3s_cnt'
		];

		foreach($dataList as $item){

			$adver_id = $item->advertiser_id;

			$industry_id = $adverIndustrys[$adver_id] ?? null;
			if( !$industry_id ){
				continue;
			}

			if( !isset($industrys[$industry_id]) ){
				continue;
			}

			foreach($columns as $column){
				$industrys[$industry_id][$column] += $item->$column;
			}

		}

		return ;
	}

	/**
	 * 获取流量助推视频-客户分日数据详情
	 */
	public static function industryFlowVideoDetails($st_date, $en_date, $industry_id, $page, $pageSize)
	{
		#获取客户
		$cust_ids = SysCustomer::where('enable', 1)->where('industry_id', $industry_id)->pluck('id')->all();
		#获取广告主
		$adverCusts = SysCustomerAdver::where('enable', 1)->whereIn('customer_id', $cust_ids)->pluck('customer_id', 'advertiser_id')->all();
		$adver_ids = array_keys($adverCusts);

		$dates = array();
		$th_date = $en_date;
		while($th_date>=$st_date){

			$dates[$th_date] = null;
			$th_date = date('Y-m-d', strtotime($th_date)-86400);
		}

		#流量助推
		$flowQtaskVideo = JxQtaskVideoFlowOrderList::selectRaw('
				advertiser_id,
				left(promotion_begin_time, 10) as idate,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('idate')
            ->groupBy('advertiser_id')
            ->get()
            ->toArray();
        if(!empty($flowQtaskVideo)){
        	foreach($flowQtaskVideo as $val){
        		$idate = $val['idate'];
        		$adver_id = $val['advertiser_id'];

        		#获取所属客户
        		$cu_id = $adverCusts[$adver_id] ?? null;
        		if(!$cu_id){
        			continue;
        		}
        		if( isset($dates[$idate]) ){
        			$dates[$idate]['cust_ids'][] = $cu_id;

        			$dates[$idate]['consume_amount'] += $val['consume_amount'];
        			$dates[$idate]['play'] += $val['play'];
        			$dates[$idate]['action'] += $val['action'];
        			$dates[$idate]['conversion'] += $val['conversion'];
        			$dates[$idate]['comment'] += $val['comment'];
        			$dates[$idate]['admire'] += $val['admire'];
        			$dates[$idate]['played3s_cnt'] += $val['played3s_cnt'];
        		} else {
        			unset($val['advertiser_id']);
        			$val['cust_ids'][] = $cu_id;
        			$dates[$idate] = $val;
        		}
        	}
        }

		$flowStarVideo = JxStarVideoFlowOrderList::selectRaw('
				advertiser_id,
				left(promotion_begin_time, 10) as idate,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('idate')
            ->groupBy('advertiser_id')
            ->get()
            ->toArray();

       	if(!empty($flowStarVideo)){
        	foreach($flowStarVideo as $val){
        		$idate = $val['idate'];
        		$adver_id = $val['advertiser_id'];

        		#获取所属客户
        		$cu_id = $adverCusts[$adver_id] ?? null;
        		if(!$cu_id){
        			continue;
        		}
        		if( isset($dates[$idate]) ){
        			$dates[$idate]['cust_ids'][] = $cu_id;

        			$dates[$idate]['consume_amount'] += $val['consume_amount'];
        			$dates[$idate]['play'] += $val['play'];
        			$dates[$idate]['action'] += $val['action'];
        			$dates[$idate]['conversion'] += $val['conversion'];
        			$dates[$idate]['comment'] += $val['comment'];
        			$dates[$idate]['admire'] += $val['admire'];
        			$dates[$idate]['played3s_cnt'] += $val['played3s_cnt'];
        		} else {
        			unset($val['advertiser_id']);
        			$val['cust_ids'][] = $cu_id;
        			$dates[$idate] = $val;
        		}
        	}
        }

        $dates = array_values(array_filter($dates));
        if(!empty($dates)){
        	foreach($dates as &$val){
        		#计算值补充
        		$val['cust_count'] = count(array_unique($val['cust_ids']));
	        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
	        	$val['played3s_percent'] = $val['play']>0 ? round($val['played3s_cnt']/$val['play']*100, 2) : 0;
	        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
	        	$val['cpm'] = $val['play']>0 ? round($val['consume_amount']/$val['play']*1000, 2) : null;
	        	$val['cpc'] = $val['action']>0 ? round($val['consume_amount']/$val['action'], 2) : null;
	        	$val['cpa'] = $val['conversion']>0 ? round($val['consume_amount']/$val['conversion'], 2) : null;
        	}
        }

        $offset = ($page-1) * $pageSize;
        $total = count($dates);
        $dates = array_slice($dates, $offset, $pageSize);

        return [$dates, $total];
	}

	public static function industryFlowVideoCustDetails($date, $industry_id)
	{
		#获取客户
		$custInfos = SysCustomer::where('enable', 1)->where('industry_id', $industry_id)->pluck('name', 'id')->all();
		$cust_ids = array_keys($custInfos);
		#获取广告主
		$adverCusts = SysCustomerAdver::where('enable', 1)->whereIn('customer_id', $cust_ids)->pluck('customer_id', 'advertiser_id')->all();
		$adver_ids = array_keys($adverCusts);

		$flowQtaskVideo = JxQtaskVideoFlowOrderList::selectRaw('
				advertiser_id,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $date)
			->where('promotion_begin_time', '<=', $date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('advertiser_id')
            ->get()
            ->toArray();

		$flowStarVideo = JxStarVideoFlowOrderList::selectRaw('
				advertiser_id,
				sum(consume_amount) as consume_amount,
				sum(play) as play,
				sum(action) as action,
				sum(conversion) as conversion,
				sum(comment) as comment,
				sum(admire) as admire,
				sum(played3s_cnt) as played3s_cnt
			')
			->where('promotion_begin_time', '>=', $date)
			->where('promotion_begin_time', '<=', $date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('advertiser_id')
            ->get()
            ->toArray();

        $ret = array();
        foreach($flowQtaskVideo as $val) {
        	$adver_id = $val['advertiser_id'];
        	$cu_id = $adverCusts[$adver_id] ?? null;
        	if(!$cu_id){
        		continue;
        	}

        	if(isset($ret[$cu_id])){
        		$ret[$cu_id]['consume_amount'] += $val['consume_amount'];
        		$ret[$cu_id]['play'] += $val['play'];
        		$ret[$cu_id]['action'] += $val['action'];
        		$ret[$cu_id]['conversion'] += $val['conversion'];
        		$ret[$cu_id]['comment'] += $val['comment'];
        		$ret[$cu_id]['admire'] += $val['admire'];
        		$ret[$cu_id]['played3s_cnt'] += $val['played3s_cnt'];

        	} else {
        		#客户信息
        		$val['cust_id'] = $cu_id;
        		$val['cust_name'] = $custInfos[$cu_id];
        		unset($val['advertiser_id']);
        		$ret[$cu_id] = $val;
        	}
        }

        foreach($flowStarVideo as $val) {
        	$adver_id = $val['advertiser_id'];
        	$cu_id = $adverCusts[$adver_id] ?? null;
        	if(!$cu_id){
        		continue;
        	}

        	if(isset($ret[$cu_id])){
        		$ret[$cu_id]['consume_amount'] += $val['consume_amount'];
        		$ret[$cu_id]['play'] += $val['play'];
        		$ret[$cu_id]['action'] += $val['action'];
        		$ret[$cu_id]['conversion'] += $val['conversion'];
        		$ret[$cu_id]['comment'] += $val['comment'];
        		$ret[$cu_id]['admire'] += $val['admire'];
        		$ret[$cu_id]['played3s_cnt'] += $val['played3s_cnt'];

        	} else {
        		#客户信息
        		$val['cust_id'] = $cu_id;
        		$val['cust_name'] = $custInfos[$cu_id];
        		unset($val['advertiser_id']);
        		$ret[$cu_id] = $val;
        	}
        }

        foreach($ret as &$val){
        	$val['idate'] = $date;
        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
        	$val['played3s_percent'] = $val['play']>0 ? round($val['played3s_cnt']/$val['play']*100, 2) : 0;
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['consume_amount']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['consume_amount']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['consume_amount']/$val['conversion'], 2) : null;
        }

        return array_values($ret);
	}

	public static function costTotal($st_date, $en_date)
	{
		#增加当前登录用户权限限制，查客户信息
		$userInfo = Auth::user();

		$res = JxCostDailyData::where('enable', 1)
			->where('day', '>=', $st_date)
			->where('day', '<=', $en_date)
			->whereIn('customer_id', $userInfo->custIds)
			->selectRaw('
				sum(star_video_cost) as starVideoCost,
				sum(star_live_cost) as starLiveCost,
				sum(qtask_video_cost)+sum(qtask_live_cost) as qTaskCost,
				sum(flow_star_video_cost)+sum(flow_star_live_cost)+sum(flow_qtask_video_cost) as flowCost
			')
			->first();

		$starVideoCost = $res->starVideoCost ?? 0;
		$starLiveCost = $res->starLiveCost ?? 0;
		$qTaskCost = $res->qTaskCost ?? 0;
		$flowCost = $res->flowCost ?? 0;

		$starVideoCost = round($starVideoCost/1000, 2);
        $starLiveCost = round($starLiveCost/1000, 2);
        $qTaskCost = round($qTaskCost/1000, 2);
        $flowCost = round($flowCost/1000, 2);

        #总消耗
        $totalCost = round($starVideoCost
        	+ $starLiveCost
        	+ $qTaskCost
        	+ $flowCost, 2);

		return [
        	'totalCost' => $totalCost,
        	'starVideoCost' => $starVideoCost,
        	'starLiveCost' => $starLiveCost,
        	'qTaskCost' => $qTaskCost,
        	'flowCost' => $flowCost
        ];

	}

	public static function custCostLists($st_date, $en_date, $sort, $sort_type, $page, $pageSize)
	{
		#增加当前登录用户权限限制，查客户信息
		$userInfo = Auth::user();

		$res = JxCostDailyData::where('enable', 1)
			->where('day', '>=', $st_date)
			->where('day', '<=', $en_date)
			->whereIn('customer_id', $userInfo->custIds)
			->selectRaw('
				customer_id,
				sum(star_video_cost) as starVideoCost,
				sum(star_live_cost) as starLiveCost,
				sum(qtask_video_cost)+sum(qtask_live_cost) as qTaskCost,
				sum(flow_star_video_cost)+sum(flow_star_live_cost)+sum(flow_qtask_video_cost) as flowCost
			')
			->groupBy('customer_id')
			->get()
			->toArray();

		$total = count($res);

		if(!$total){
			return [null, 0];
		}

		$cust_ids = array_column($res, 'customer_id');
		$custInfos = SysCustomer::where('enable', 1)->whereIn('id', $cust_ids)->pluck('name', 'id')->all();

		foreach($res as &$val){
			$val['id'] = $val['customer_id'];
			$val['name'] = $custInfos[$val['id']] ?? '';

			$val['starVideoCost'] = round($val['starVideoCost']/1000, 2);
	        $val['starLiveCost'] = round($val['starLiveCost']/1000, 2);
	        $val['qTaskCost'] = round($val['qTaskCost']/1000, 2);
	        $val['flowCost'] = round($val['flowCost']/1000, 2);

	        #总消耗
	        $val['totalCost'] = round($val['starVideoCost']
	        	+ $val['starLiveCost']
	        	+ $val['qTaskCost']
	        	+ $val['flowCost'], 2);
		}

		if($sort_type){
        	array_multisort(array_column($res, $sort), SORT_ASC, $res);
        } else {
        	array_multisort(array_column($res, $sort), SORT_DESC, $res);
        }

        $offset = ($page-1) * $pageSize;
        $res = array_slice($res, $offset, $pageSize);

        return [$res, $total];
	}

	public static function industryFlowLiveList($st_date, $en_date, $sort, $sort_type, $page, $pageSize)
	{
		#查客户信息
		$userInfo = Auth::user();
		$custIndustryIds = SysCustomer::where('enable', 1)->whereIn('id', $userInfo->custIds)->pluck('industry_id', 'id')->all();

		#行业信息
		$industrys = SysIndustry::whereIn('industry_id', $custIndustryIds)->select('industry_name', 'industry_id')->get()->keyBy('industry_id')->toArray();

		$_cols = [
        	'consume_amount' => 0,
        	'audience_num' => 0,   //引入观众数
        	'played3s_num' => 0,    //观看3秒+观众数
        	'fans_increase_num' => 0,  //涨粉数
        	'item_impression_num' => 0,  //推广直播间曝光数
        	'interactive_num' => 0,      //互动数
        	'conversion_impression_num' => 0, //组件曝光数
        	'conversion_action_num' => 0,   //行为数
        	'cash_amount' => 0,
        	'client_amount' => 0,
        	'agency_amount' => 0,
        	'credit_consume_amount' => 0,
        	'ctr' => 0,  //行为率
        	'cpa' => 0  //激活成本
        ];

        foreach($industrys as &$val){
        	$val = array_merge($val, $_cols);
        }

		#查客户广告主关系
		$advers = SysCustomerAdver::select('customer_id', 'advertiser_id')->where('enable', 1)->get()->keyBy('advertiser_id')->toArray();
		$adverIndustrys = array();
		foreach($advers as $adver_id=>$v){
			$cu_id = $v['customer_id'];

			$industry_id = $custIndustryIds[$cu_id] ?? null;
			if($industry_id){
				$adverIndustrys[$adver_id] = $industry_id;
			}
		}

		#流量助推
		$flowStarLive = JxStarLiveFlowOrderList::selectRaw('
				advertiser_id,
				sum(consume_amount) as consume_amount,
				sum(audience_num) as audience_num,
				sum(played3s_num) as played3s_num,
				sum(fans_increase_num) as fans_increase_num,
				sum(item_impression_num) as item_impression_num,
				sum(interactive_num) as interactive_num,
				sum(conversion_impression_num) as conversion_impression_num,
				sum(conversion_action_num) as conversion_action_num,
				sum(cash_amount) as cash_amount,
				sum(client_amount) as client_amount,
				sum(agency_amount) as agency_amount,
				sum(credit_consume_amount) as credit_consume_amount
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();

        if(!empty($flowStarLive)){
        	self::industryFlowLiveDivide($flowStarLive, $adverIndustrys, $industrys);
        }

        foreach($industrys as &$val){
        	#计算值补充
        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
        	$val['cash_amount'] = round($val['cash_amount']/1000, 2);
        	$val['client_amount'] = round($val['client_amount']/1000, 2);
        	$val['agency_amount'] = round($val['agency_amount']/1000, 2);
        	$val['credit_consume_amount'] = round($val['credit_consume_amount']/1000, 2);

        	$val['ctr'] = $val['conversion_impression_num']>0 ? round($val['conversion_action_num']/$val['conversion_impression_num']*100, 2) : 0;
        	$val['cpa'] = $val['conversion_action_num']>0 ? round($val['consume_amount']/$val['conversion_action_num'], 2) : null;
        }

        if($sort_type){
        	array_multisort(array_column($industrys, $sort), SORT_ASC, $industrys);
        } else {
        	array_multisort(array_column($industrys, $sort), SORT_DESC, $industrys);
        }

        $offset = ($page-1) * $pageSize;
        $total = count($industrys);
        $industrys = array_slice($industrys, $offset, $pageSize);

        return [$industrys, $total];
	}

	public static function industryFlowLiveDivide($dataList, $adverIndustrys, &$industrys)
	{
		$columns = [
			'consume_amount',
        	'audience_num',   //引入观众数
        	'played3s_num',    //观看3秒+观众数
        	'fans_increase_num',  //涨粉数
        	'item_impression_num',  //推广直播间曝光数
        	'interactive_num',      //互动数
        	'conversion_impression_num', //组件曝光数
        	'conversion_action_num',   //行为数
        	'cash_amount',
        	'client_amount',
        	'agency_amount',
        	'credit_consume_amount'
		];

		foreach($dataList as $item){

			$adver_id = $item->advertiser_id;

			$industry_id = $adverIndustrys[$adver_id] ?? null;
			if( !$industry_id ){
				continue;
			}

			if( !isset($industrys[$industry_id]) ){
				continue;
			}

			foreach($columns as $column){
				$industrys[$industry_id][$column] += $item->$column;
			}

		}

		return ;
	}

	public static function industryFlowLiveDetails($st_date, $en_date, $industry_id, $page, $pageSize)
	{
   		#获取客户
		$cust_ids = SysCustomer::where('enable', 1)->where('industry_id', $industry_id)->pluck('id')->all();
		#获取广告主
		$adverCusts = SysCustomerAdver::where('enable', 1)->whereIn('customer_id', $cust_ids)->pluck('customer_id', 'advertiser_id')->all();
		$adver_ids = array_keys($adverCusts);

		$dates = array();
		$th_date = $en_date;
		while($th_date>=$st_date){
			$dates[$th_date] = null;
			$th_date = date('Y-m-d', strtotime($th_date)-86400);
		}

		#流量助推
		$flowStarLive = JxStarLiveFlowOrderList::selectRaw('
				advertiser_id,
				left(promotion_begin_time, 10) as idate,
				sum(consume_amount) as consume_amount,
				sum(audience_num) as audience_num,
				sum(played3s_num) as played3s_num,
				sum(fans_increase_num) as fans_increase_num,
				sum(item_impression_num) as item_impression_num,
				sum(interactive_num) as interactive_num,
				sum(conversion_impression_num) as conversion_impression_num,
				sum(conversion_action_num) as conversion_action_num,
				sum(cash_amount) as cash_amount,
				sum(client_amount) as client_amount,
				sum(agency_amount) as agency_amount,
				sum(credit_consume_amount) as credit_consume_amount
			')
			->where('promotion_begin_time', '>=', $st_date)
			->where('promotion_begin_time', '<=', $en_date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('idate')
            ->groupBy('advertiser_id')
            ->get()
            ->toArray();
        if(!empty($flowStarLive)){
        	foreach($flowStarLive as $val){
        		$idate = $val['idate'];
        		$adver_id = $val['advertiser_id'];

        		#获取所属客户
        		$cu_id = $adverCusts[$adver_id] ?? null;
        		if(!$cu_id){
        			continue;
        		}
        		if( isset($dates[$idate]) ){
        			$dates[$idate]['cust_ids'][] = $cu_id;

        			$dates[$idate]['consume_amount'] += $val['consume_amount'];
        			$dates[$idate]['audience_num'] += $val['audience_num'];
        			$dates[$idate]['played3s_num'] += $val['played3s_num'];
        			$dates[$idate]['fans_increase_num'] += $val['fans_increase_num'];
        			$dates[$idate]['item_impression_num'] += $val['item_impression_num'];
        			$dates[$idate]['interactive_num'] += $val['interactive_num'];
        			$dates[$idate]['conversion_impression_num'] += $val['conversion_impression_num'];
        			$dates[$idate]['conversion_action_num'] += $val['conversion_action_num'];
        			$dates[$idate]['cash_amount'] += $val['cash_amount'];
        			$dates[$idate]['client_amount'] += $val['client_amount'];
        			$dates[$idate]['agency_amount'] += $val['agency_amount'];
        			$dates[$idate]['credit_consume_amount'] += $val['credit_consume_amount'];

        		} else {
        			unset($val['advertiser_id']);
        			$val['cust_ids'][] = $cu_id;
        			$dates[$idate] = $val;
        		}
        	}
        }

        $dates = array_values(array_filter($dates));

        if(!empty($dates)){
        	foreach($dates as &$val){
        		#计算值补充
        		$val['cust_count'] = count(array_unique($val['cust_ids']));

	        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
	        	$val['cash_amount'] = round($val['cash_amount']/1000, 2);
	        	$val['client_amount'] = round($val['client_amount']/1000, 2);
	        	$val['agency_amount'] = round($val['agency_amount']/1000, 2);
	        	$val['credit_consume_amount'] = round($val['credit_consume_amount']/1000, 2);

	        	$val['ctr'] = $val['conversion_impression_num']>0 ? round($val['conversion_action_num']/$val['conversion_impression_num']*100, 2) : 0;
	        	$val['cpa'] = $val['conversion_action_num']>0 ? round($val['consume_amount']/$val['conversion_action_num'], 2) : null;
        	}
        }

        $offset = ($page-1) * $pageSize;
        $total = count($dates);
        $dates = array_slice($dates, $offset, $pageSize);

        return [$dates, $total];

	}

	public static function industryFlowLiveCustDetails($date, $industry_id)
	{
        #获取客户
		$custInfos = SysCustomer::where('enable', 1)->where('industry_id', $industry_id)->pluck('name', 'id')->all();
		$cust_ids = array_keys($custInfos);
		#获取广告主
		$adverCusts = SysCustomerAdver::where('enable', 1)->whereIn('customer_id', $cust_ids)->pluck('customer_id', 'advertiser_id')->all();
		$adver_ids = array_keys($adverCusts);

		$flowStarLive = JxStarLiveFlowOrderList::selectRaw('
				advertiser_id,
				sum(consume_amount) as consume_amount,
				sum(audience_num) as audience_num,
				sum(played3s_num) as played3s_num,
				sum(fans_increase_num) as fans_increase_num,
				sum(item_impression_num) as item_impression_num,
				sum(interactive_num) as interactive_num,
				sum(conversion_impression_num) as conversion_impression_num,
				sum(conversion_action_num) as conversion_action_num,
				sum(cash_amount) as cash_amount,
				sum(client_amount) as client_amount,
				sum(agency_amount) as agency_amount,
				sum(credit_consume_amount) as credit_consume_amount
			')
			->where('promotion_begin_time', '>=', $date)
			->where('promotion_begin_time', '<=', $date.' 23:59:59')
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('advertiser_id')
            ->get()
            ->toArray();

        $ret = array();
        foreach($flowStarLive as $val) {
        	$adver_id = $val['advertiser_id'];
        	$cu_id = $adverCusts[$adver_id] ?? null;
        	if(!$cu_id){
        		continue;
        	}

        	if(isset($ret[$cu_id])){
        		$ret[$cu_id]['consume_amount'] += $val['consume_amount'];
        		$ret[$cu_id]['audience_num'] += $val['audience_num'];
        		$ret[$cu_id]['played3s_num'] += $val['played3s_num'];
        		$ret[$cu_id]['fans_increase_num'] += $val['fans_increase_num'];
        		$ret[$cu_id]['item_impression_num'] += $val['item_impression_num'];
        		$ret[$cu_id]['interactive_num'] += $val['interactive_num'];
        		$ret[$cu_id]['conversion_impression_num'] += $val['conversion_impression_num'];
        		$ret[$cu_id]['conversion_action_num'] += $val['conversion_action_num'];
        		$ret[$cu_id]['cash_amount'] += $val['cash_amount'];
        		$ret[$cu_id]['client_amount'] += $val['client_amount'];
        		$ret[$cu_id]['agency_amount'] += $val['agency_amount'];
        		$ret[$cu_id]['credit_consume_amount'] += $val['credit_consume_amount'];

        	} else {
        		#客户信息
        		$val['cust_id'] = $cu_id;
        		$val['cust_name'] = $custInfos[$cu_id];
        		unset($val['advertiser_id']);
        		$ret[$cu_id] = $val;
        	}
        }

        foreach($ret as &$val){
        	$val['idate'] = $date;

        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
        	$val['cash_amount'] = round($val['cash_amount']/1000, 2);
        	$val['client_amount'] = round($val['client_amount']/1000, 2);
        	$val['agency_amount'] = round($val['agency_amount']/1000, 2);
        	$val['credit_consume_amount'] = round($val['credit_consume_amount']/1000, 2);
        	$val['ctr'] = $val['conversion_impression_num']>0 ? round($val['conversion_action_num']/$val['conversion_impression_num']*100, 2) : 0;
        	$val['cpa'] = $val['conversion_action_num']>0 ? round($val['consume_amount']/$val['conversion_action_num'], 2) : null;
        }

        return array_values($ret);
	}

	public static function svfDailyData($cust_id, $start, $end, $page, $pageSize)
	{
		#获取广告主id
		$adver_ids = SysCustomerAdver::where('customer_id', $cust_id)->where('enable', 1)->pluck('advertiser_id')->all();
		if(empty($adver_ids)){
			return null;
		}

		$res = JxStarVideoFlowOrderDailyData::selectRaw('
				date,
				sum(consume_amount_incr) as consume_amount,
				sum(view_incr) as view,
				sum(event_pay_incr) as event_pay,
				sum(play_incr) as play,
				sum(action_incr) as action,
				sum(conversion_incr) as conversion,
				sum(comment_incr) as comment,
				sum(admire_incr) as admire,
				sum(played3s_cnt_incr) as played3s_cnt,
				sum(submissions_number_incr) as submissions_number
			')
			->whereIn('advertiser_id', $adver_ids)
			->where('date', '>=', $start)
			->where('date', '<=', $end)
			->where('date', '>', '2023-02-23')
			->groupBy('date')
			->orderBy('date', 'desc')
			->get()
			->toArray();

		$total = count($res);
		$offset = ($page-1) * $pageSize;
		$res = array_slice($res, $offset, $pageSize);

		foreach($res as &$val){
			#计算值补充
        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
        	$val['played3s_percent'] = $val['play']>0 ? round($val['played3s_cnt']/$val['play']*100, 2) : 0;
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['consume_amount']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['consume_amount']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['consume_amount']/$val['conversion'], 2) : null;

        	if($val['date']<='2023-04-04'){
        		$val['submissions_number'] = 0;// 4号上线第一天不统计
        	}
        	$val['sub_cpa'] = $val['submissions_number']>0 ? round($val['consume_amount']/$val['submissions_number'], 2) : null;
		}

		return [$res, $total];
	}

	public static function svfDailyUserData($cust_id, $date, $sort)
	{
		#获取广告主id
		$adver_ids = SysCustomerAdver::where('customer_id', $cust_id)->where('enable', 1)->pluck('advertiser_id')->all();
		if(empty($adver_ids)){
			return null;
		}

		if(!$sort){
			$sort = 'user_id';
		}

		$res = JxStarVideoFlowOrderDailyData::selectRaw('
				user_id,
				task_id,
				any_value(star_name) as star_name,
				sum(consume_amount_incr) as consume_amount,
				sum(view_incr) as view,
				sum(play_incr) as play,
				sum(action_incr) as action,
				sum(conversion_incr) as conversion,
				sum(comment_incr) as comment,
				sum(admire_incr) as admire,
				sum(played3s_cnt_incr) as played3s_cnt,
				sum(submissions_number_incr) as submissions_number
			')
			->whereIn('advertiser_id', $adver_ids)
			->where('date', $date)
			->groupBy('user_id')
			->groupBy('task_id')
			->orderBy($sort, 'desc')
			->get()
			->toArray();

		if(empty($res)){
			return null;
		}

		$user_ids = array_column($res, 'user_id');
		#达人头像，粉丝数
        $userInfos = JxStarUsers::select('user_id', 'head_url', 'fans_number', 'gender')->whereIn('user_id', $user_ids)->get()->keyBy('user_id')->toArray();

		foreach($res as &$val){
			#计算值补充
        	$val['consume_amount'] = round($val['consume_amount']/1000, 2);
        	$val['played3s_percent'] = $val['play']>0 ? round($val['played3s_cnt']/$val['play']*100, 2) : 0;
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['consume_amount']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['consume_amount']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['consume_amount']/$val['conversion'], 2) : null;

        	if($date<='2023-04-04'){
        		$val['submissions_number'] = 0;// 4号上线第一天不统计
        	}
        	$val['sub_cpa'] = $val['submissions_number']>0 ? round($val['consume_amount']/$val['submissions_number'], 2) : null;

        	$uid = $val['user_id'];
        	$val['fan'] = $userInfos[$uid]['fans_number'] ?? null;
        	$val['head_url'] = $userInfos[$uid]['head_url'] ?? null;

        	if($val['star_name'] == 'None'){
        		$val['star_name'] = '未知';
        	}
		}

		return $res;
	}

	public static function svfDataUp($cust_id)
	{
		$rk = 'svfDataUp-lock';

		if( !RedisModel::setnx($rk, 1) ){
			return 1200;
		}

		#获取广告主id
		$adver_ids = SysCustomerAdver::where('customer_id', $cust_id)->where('enable', 1)->pluck('advertiser_id')->all();
		if(empty($adver_ids)){
			return 500;
		}

        # 设置时间
        $stTime = date('Y-m-d', strtotime('-27 day'));
        $enTime = date('Y-m-d');

        # 获取时间段数组
        $timeRangeArr = getTimeRangeArr($stTime, $enTime);

        foreach ($adver_ids as $adver_Id) {
            # 插入队列
            $advertiserItem = [
                'advertiserId' => $adver_Id,
                'timeRangeArr' => $timeRangeArr
            ];
            RedisModel::lPush(JuxingAdAccount::JUXING_FLOW_STAR_VIDEO_DAILY_SYNC_ADVID_LIST, json_encode($advertiserItem));
        }

        RedisModel::expire($rk, 60);

		return 0;
	}

	public static function qtaskVideoDailyData($cust_id, $start, $end, $page, $pageSize)
	{
		#获取广告主id
		$adver_ids = SysCustomerAdver::where('customer_id', $cust_id)->where('enable', 1)->pluck('advertiser_id')->all();
		if(empty($adver_ids)){
			return null;
		}

		$res = JxQtaskVideoOrderDaily::selectRaw('
				idate,
				sum(cost) as cost,
				sum(view) as view,
				sum(play) as play,
				sum(action) as action,
				sum(admire) as admire,
				sum(comment) as comment,
				sum(item_impression_cnt) as item_impression_cnt,
				sum(item_click_cnt) as item_click_cnt,
				sum(play_5s) as play_5s,
				sum(play_3s) as play_3s,
				sum(app_download) as app_download,
				sum(conversion_num) as conversion,
				sum(share_num) as share_num
			')
			->whereIn('advertiser_id', $adver_ids)
			->where('idate', '>=', $start)
			->where('idate', '<=', $end)
			->groupBy('idate')
			->orderBy('idate', 'desc')
			->get()
			->toArray();

		$total = count($res);
		$offset = ($page-1) * $pageSize;
		$res = array_slice($res, $offset, $pageSize);

		foreach($res as &$val){
			#计算值补充
        	$val['cost'] = round($val['cost']/1000, 2);
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['cost']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['cost']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
		}

		return [$res, $total];
	}

	public static function qtaskVideoTaskDailyData($cust_id, $date, $sort)
	{
		#获取广告主id
		$adver_ids = SysCustomerAdver::where('customer_id', $cust_id)->where('enable', 1)->pluck('advertiser_id')->all();
		if(empty($adver_ids)){
			return null;
		}

		if(!$sort){
			$sort = 'play';
		}

		$res = JxQtaskVideoOrderDaily::selectRaw('
				task_id,
				sum(cost) as cost,
				sum(view) as view,
				sum(play) as play,
				sum(action) as action,
				sum(admire) as admire,
				sum(comment) as comment,
				sum(item_impression_cnt) as item_impression_cnt,
				sum(item_click_cnt) as item_click_cnt,
				sum(play_5s) as play_5s,
				sum(play_3s) as play_3s,
				sum(app_download) as app_download,
				sum(conversion_num) as conversion,
				sum(share_num) as share_num
			')
			->whereIn('advertiser_id', $adver_ids)
			->where('idate', $date)
			->groupBy('task_id')
			->orderBy($sort, 'desc')
			->get()
			->toArray();

		if(empty($res)){
			return null;
		}

		foreach($res as &$val){
			#计算值补充
        	$val['cost'] = round($val['cost']/1000, 2);
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['cost']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['cost']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
		}

		return $res;
	}

	public static function qtaskVideoOrderDailyData($cust_id, $task_id, $date, $sort)
	{
		#获取广告主id
		$adver_ids = SysCustomerAdver::where('customer_id', $cust_id)->where('enable', 1)->pluck('advertiser_id')->all();
		if(empty($adver_ids)){
			return null;
		}

		if(!$sort){
			$sort = 'play';
		}

		$res = JxQtaskVideoOrderDaily::selectRaw('
				user_id,
				order_id,
				star_name,
				cost,
				view,
				play,
				action,
				admire,
				comment,
				item_impression_cnt,
				item_click_cnt,
				play_5s,
				play_3s,
				app_download,
				conversion_num as conversion,
				share_num
			')
			->whereIn('advertiser_id', $adver_ids)
			->where('idate', $date)
			->where('task_id', $task_id)
			->orderBy($sort, 'desc')
			->get()
			->toArray();

		if(empty($res)){
			return null;
		}

		$user_ids = array_column($res, 'user_id');
		#达人头像，粉丝数
        $userInfos = JxStarUsers::select('user_id', 'head_url', 'fans_number', 'gender')->whereIn('user_id', $user_ids)->get()->keyBy('user_id')->toArray();

		foreach($res as &$val){
			#计算值补充
        	$val['cost'] = round($val['cost']/1000, 2);
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['cost']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['cost']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;

        	$uid = $val['user_id'];
        	$val['fan'] = $userInfos[$uid]['fans_number'] ?? null;
        	$val['head_url'] = $userInfos[$uid]['head_url'] ?? null;

        	if($val['star_name'] == 'None'){
        		$val['star_name'] = '未知';
        	}
		}

		return $res;
	}

	public static function qtaskLiveDailyData($cust_id, $start, $end, $page, $pageSize)
	{
		#获取广告主id
		$adver_ids = SysCustomerAdver::where('customer_id', $cust_id)->where('enable', 1)->pluck('advertiser_id')->all();
		if(empty($adver_ids)){
			return null;
		}

		$res = JxQtaskLiveOrderDaily::selectRaw('
				idate,
				sum(cost) as cost,
				sum(item_impression_cnt) as item_impression_cnt,
				sum(item_click_cnt) as item_click_cnt,
				sum(app_download) as app_download,
				sum(conversion_num) as conversion
			')
			->whereIn('advertiser_id', $adver_ids)
			->where('idate', '>=', $start)
			->where('idate', '<=', $end)
			->groupBy('idate')
			->orderBy('idate', 'desc')
			->get()
			->toArray();

		$total = count($res);
		$offset = ($page-1) * $pageSize;
		$res = array_slice($res, $offset, $pageSize);

		foreach($res as &$val){
			#计算值补充
        	$val['cost'] = round($val['cost']/1000, 2);
        	$val['ctr'] = $val['item_impression_cnt']>0 ? round($val['item_click_cnt']/$val['item_impression_cnt']*100, 2) : 0;
        	$val['cpc'] = $val['item_click_cnt']>0 ? round($val['cost']/$val['item_click_cnt'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
		}

		return [$res, $total];
	}

	public static function qtaskLiveTaskDailyData($cust_id, $date, $sort)
	{
		#获取广告主id
		$adver_ids = SysCustomerAdver::where('customer_id', $cust_id)->where('enable', 1)->pluck('advertiser_id')->all();
		if(empty($adver_ids)){
			return null;
		}

		if(!$sort){
			$sort = 'item_impression_cnt';
		}

		$res = JxQtaskLiveOrderDaily::selectRaw('
				task_id,
				sum(cost) as cost,
				sum(item_impression_cnt) as item_impression_cnt,
				sum(item_click_cnt) as item_click_cnt,
				sum(app_download) as app_download,
				sum(conversion_num) as conversion
			')
			->whereIn('advertiser_id', $adver_ids)
			->where('idate', $date)
			->groupBy('task_id')
			->orderBy($sort, 'desc')
			->get()
			->toArray();

		if(empty($res)){
			return null;
		}

		foreach($res as &$val){
			#计算值补充
        	$val['cost'] = round($val['cost']/1000, 2);
        	$val['ctr'] = $val['item_impression_cnt']>0 ? round($val['item_click_cnt']/$val['item_impression_cnt']*100, 2) : 0;
        	$val['cpc'] = $val['item_click_cnt']>0 ? round($val['cost']/$val['item_click_cnt'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
		}

		return $res;
	}

	public static function qtaskLiveOrderDailyData($cust_id, $task_id, $date, $sort)
	{
		#获取广告主id
		$adver_ids = SysCustomerAdver::where('customer_id', $cust_id)->where('enable', 1)->pluck('advertiser_id')->all();
		if(empty($adver_ids)){
			return null;
		}

		if(!$sort){
			$sort = 'item_impression_cnt';
		}

		$res = JxQtaskLiveOrderDaily::selectRaw('
				user_id,
				order_id,
				star_name,
				cost,
				item_impression_cnt,
				item_click_cnt,
				app_download,
				conversion_num as conversion
			')
			->whereIn('advertiser_id', $adver_ids)
			->where('idate', $date)
			->where('task_id', $task_id)
			->orderBy($sort, 'desc')
			->get()
			->toArray();

		if(empty($res)){
			return null;
		}

		$user_ids = array_column($res, 'user_id');
		#达人头像，粉丝数
        $userInfos = JxStarUsers::select('user_id', 'head_url', 'fans_number', 'gender')->whereIn('user_id', $user_ids)->get()->keyBy('user_id')->toArray();

		foreach($res as &$val){
			#计算值补充
        	$val['cost'] = round($val['cost']/1000, 2);
        	$val['ctr'] = $val['item_impression_cnt']>0 ? round($val['item_click_cnt']/$val['item_impression_cnt']*100, 2) : 0;
        	$val['cpc'] = $val['item_click_cnt']>0 ? round($val['cost']/$val['item_click_cnt'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;

        	$uid = $val['user_id'];
        	$val['fan'] = $userInfos[$uid]['fans_number'] ?? null;
        	$val['head_url'] = $userInfos[$uid]['head_url'] ?? null;

        	if($val['star_name'] == 'None'){
        		$val['star_name'] = '未知';
        	}
		}

		return $res;
	}

	public static function industryQtaskVideoList($st_date, $en_date, $sort, $sort_type, $page, $pageSize)
	{
		#查客户信息
		$userInfo = Auth::user();
		$custIndustryIds = SysCustomer::where('enable', 1)->whereIn('id', $userInfo->custIds)->pluck('industry_id', 'id')->all();

		#行业信息
		$industrys = SysIndustry::whereIn('industry_id', $custIndustryIds)->select('industry_name', 'industry_id')->get()->keyBy('industry_id')->toArray();

		$_cols = [
        	'cost' => 0,
        	'view' => 0,
        	'play' => 0,
        	'action' => 0,
        	'admire' => 0,
        	'comment' => 0,
        	'item_impression_cnt' => 0,
        	'item_click_cnt' => 0,
        	'play_5s' => 0,
        	'play_3s' => 0,
        	'app_download' => 0,
        	'conversion' => 0,
        	'share_num' => 0,
        	'ctr' => 0,  //行为率
        	'cpm' => 0,  //千次播放成本
        	'cpc' => 0,  //点击成本
        	'cpa' => 0  //激活成本
        ];

        foreach($industrys as &$val){
        	$val = array_merge($val, $_cols);
        }

		#查客户广告主关系
		$advers = SysCustomerAdver::select('customer_id', 'advertiser_id')->where('enable', 1)->get()->keyBy('advertiser_id')->toArray();
		$adverIndustrys = array();
		foreach($advers as $adver_id=>$v){
			$cu_id = $v['customer_id'];

			$industry_id = $custIndustryIds[$cu_id] ?? null;
			if($industry_id){
				$adverIndustrys[$adver_id] = $industry_id;
			}
		}

		#快任务视频
		$qtaskVideo = JxQtaskVideoOrderDaily::selectRaw('
				advertiser_id,
				sum(cost) as cost,
				sum(view) as view,
				sum(play) as play,
				sum(action) as action,
				sum(admire) as admire,
				sum(comment) as comment,
				sum(item_impression_cnt) as item_impression_cnt,
				sum(item_click_cnt) as item_click_cnt,
				sum(play_5s) as play_5s,
				sum(play_3s) as play_3s,
				sum(app_download) as app_download,
				sum(conversion_num) as conversion,
				sum(share_num) as share_num
			')
			->where('idate', '>=', $st_date)
			->where('idate', '<=', $en_date)
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();

        if(!empty($qtaskVideo)){
        	self::industryQtaskVideoDivide($qtaskVideo, $adverIndustrys, $industrys);
        }

        foreach($industrys as &$val){
        	#计算值补充
        	$val['cost'] = round($val['cost']/1000, 2);
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['cost']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['cost']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
        }

        if($sort_type){
        	array_multisort(array_column($industrys, $sort), SORT_ASC, $industrys);
        } else {
        	array_multisort(array_column($industrys, $sort), SORT_DESC, $industrys);
        }

        $offset = ($page-1) * $pageSize;
        $total = count($industrys);
        $industrys = array_slice($industrys, $offset, $pageSize);

        return [$industrys, $total];
	}

	public static function industryQtaskVideoDivide($dataList, $adverIndustrys, &$industrys)
	{
		$columns = [
			'cost',
            'view',
            'play',
            'action',
            'admire',
            'comment',
            'item_impression_cnt',
            'item_click_cnt',
            'play_5s',
            'play_3s',
            'app_download',
            'conversion',
            'share_num'
		];

		foreach($dataList as $item){

			$adver_id = $item->advertiser_id;

			$industry_id = $adverIndustrys[$adver_id] ?? null;
			if( !$industry_id ){
				continue;
			}

			if( !isset($industrys[$industry_id]) ){
				continue;
			}

			foreach($columns as $column){
				$industrys[$industry_id][$column] += $item->$column;
			}

		}

		return ;
	}

	/**
	 * 获取快任务视频-客户分日数据详情
	 */
	public static function industryQtaskVideoDetails($st_date, $en_date, $industry_id, $page, $pageSize)
	{
		#获取客户
		$cust_ids = SysCustomer::where('enable', 1)->where('industry_id', $industry_id)->pluck('id')->all();
		#获取广告主
		$adverCusts = SysCustomerAdver::where('enable', 1)->whereIn('customer_id', $cust_ids)->pluck('customer_id', 'advertiser_id')->all();
		$adver_ids = array_keys($adverCusts);

		$dates = array();
		$th_date = $en_date;
		while($th_date>=$st_date){

			$dates[$th_date] = null;
			$th_date = date('Y-m-d', strtotime($th_date)-86400);
		}

		$qtaskVideo = JxQtaskVideoOrderDaily::selectRaw('
				idate,
				advertiser_id,
				sum(cost) as cost,
				sum(view) as view,
				sum(play) as play,
				sum(action) as action,
				sum(admire) as admire,
				sum(comment) as comment,
				sum(item_impression_cnt) as item_impression_cnt,
				sum(item_click_cnt) as item_click_cnt,
				sum(play_5s) as play_5s,
				sum(play_3s) as play_3s,
				sum(app_download) as app_download,
				sum(conversion_num) as conversion,
				sum(share_num) as share_num
			')
			->where('idate', '>=', $st_date)
			->where('idate', '<=', $en_date)
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('idate')
            ->groupBy('advertiser_id')
            ->get()
            ->toArray();
        if(!empty($qtaskVideo)){
        	foreach($qtaskVideo as $val){
        		$idate = $val['idate'];
        		$adver_id = $val['advertiser_id'];

        		#获取所属客户
        		$cu_id = $adverCusts[$adver_id] ?? null;
        		if(!$cu_id){
        			continue;
        		}
        		if( isset($dates[$idate]) ){
        			$dates[$idate]['cust_ids'][] = $cu_id;

        			$dates[$idate]['cost'] += $val['cost'];
        			$dates[$idate]['view'] += $val['view'];
        			$dates[$idate]['play'] += $val['play'];
        			$dates[$idate]['action'] += $val['action'];
        			$dates[$idate]['admire'] += $val['admire'];
        			$dates[$idate]['comment'] += $val['comment'];
        			$dates[$idate]['item_impression_cnt'] += $val['item_impression_cnt'];
        			$dates[$idate]['item_click_cnt'] += $val['item_click_cnt'];
        			$dates[$idate]['play_5s'] += $val['play_5s'];
        			$dates[$idate]['play_3s'] += $val['play_3s'];
        			$dates[$idate]['app_download'] += $val['app_download'];
        			$dates[$idate]['conversion'] += $val['conversion'];
        			$dates[$idate]['share_num'] += $val['share_num'];

        		} else {
        			unset($val['advertiser_id']);
        			$val['cust_ids'][] = $cu_id;
        			$dates[$idate] = $val;
        		}
        	}
        }

        $dates = array_values(array_filter($dates));
        if(!empty($dates)){
        	foreach($dates as &$val){
        		#计算值补充
        		$val['cost'] = round($val['cost']/1000, 2);
	        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
	        	$val['cpm'] = $val['play']>0 ? round($val['cost']/$val['play']*1000, 2) : null;
	        	$val['cpc'] = $val['action']>0 ? round($val['cost']/$val['action'], 2) : null;
	        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
	        	$val['cust_count'] = count($val['cust_ids']);
        	}
        }

        $offset = ($page-1) * $pageSize;
        $total = count($dates);
        $dates = array_slice($dates, $offset, $pageSize);

        return [$dates, $total];
	}

	public static function industryQtaskVideoCustDetails($date, $industry_id)
	{
		#获取客户
		$custInfos = SysCustomer::where('enable', 1)->where('industry_id', $industry_id)->pluck('name', 'id')->all();
		$cust_ids = array_keys($custInfos);
		#获取广告主
		$adverCusts = SysCustomerAdver::where('enable', 1)->whereIn('customer_id', $cust_ids)->pluck('customer_id', 'advertiser_id')->all();
		$adver_ids = array_keys($adverCusts);

		$qtaskVideo = JxQtaskVideoOrderDaily::selectRaw('
				advertiser_id,
				sum(cost) as cost,
				sum(view) as view,
				sum(play) as play,
				sum(action) as action,
				sum(admire) as admire,
				sum(comment) as comment,
				sum(item_impression_cnt) as item_impression_cnt,
				sum(item_click_cnt) as item_click_cnt,
				sum(play_5s) as play_5s,
				sum(play_3s) as play_3s,
				sum(app_download) as app_download,
				sum(conversion_num) as conversion,
				sum(share_num) as share_num
			')
			->where('idate', $date)
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('advertiser_id')
            ->get()
            ->toArray();

        $ret = array();
        foreach($qtaskVideo as $val) {
        	$adver_id = $val['advertiser_id'];
        	$cu_id = $adverCusts[$adver_id] ?? null;
        	if(!$cu_id){
        		continue;
        	}

        	if(isset($ret[$cu_id])){
        		$ret[$cu_id]['cost'] += $val['cost'];
        		$ret[$cu_id]['view'] += $val['view'];
        		$ret[$cu_id]['play'] += $val['play'];
        		$ret[$cu_id]['action'] += $val['action'];
        		$ret[$cu_id]['admire'] += $val['admire'];
        		$ret[$cu_id]['comment'] += $val['comment'];
        		$ret[$cu_id]['item_impression_cnt'] += $val['item_impression_cnt'];
        		$ret[$cu_id]['item_click_cnt'] += $val['item_click_cnt'];
        		$ret[$cu_id]['play_5s'] += $val['play_5s'];
        		$ret[$cu_id]['play_3s'] += $val['play_3s'];
        		$ret[$cu_id]['app_download'] += $val['app_download'];
        		$ret[$cu_id]['conversion'] += $val['conversion'];
        		$ret[$cu_id]['share_num'] += $val['share_num'];
        	} else {
        		#客户信息
        		$val['cust_id'] = $cu_id;
        		$val['cust_name'] = $custInfos[$cu_id];
        		unset($val['advertiser_id']);
        		$ret[$cu_id] = $val;
        	}
        }

        foreach($ret as &$val){
        	$val['idate'] = $date;
        	$val['cost'] = round($val['cost']/1000, 2);
        	$val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
        	$val['cpm'] = $val['play']>0 ? round($val['cost']/$val['play']*1000, 2) : null;
        	$val['cpc'] = $val['action']>0 ? round($val['cost']/$val['action'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
        }

        return array_values($ret);
	}

	public static function industryQtaskLiveList($st_date, $en_date, $sort, $sort_type, $page, $pageSize)
    {
        #查客户信息
        $userInfo = Auth::user();
        $custIndustryIds = SysCustomer::where('enable', 1)->whereIn('id', $userInfo->custIds)->pluck('industry_id', 'id')->all();

        #行业信息
        $industrys = SysIndustry::whereIn('industry_id', $custIndustryIds)->select('industry_name', 'industry_id')->get()->keyBy('industry_id')->toArray();

        $_cols = [
            'cost' => 0,
            'item_impression_cnt' => 0,
            'item_click_cnt' => 0,
            'app_download' => 0,
            'conversion' => 0,
            'ctr' => 0,  //行为率
            'cpc' => 0,  //点击成本
            'cpa' => 0  //激活成本
        ];

        foreach($industrys as &$val){
            $val = array_merge($val, $_cols);
        }

        #查客户广告主关系
        $advers = SysCustomerAdver::select('customer_id', 'advertiser_id')->where('enable', 1)->get()->keyBy('advertiser_id')->toArray();
        $adverIndustrys = array();
        foreach($advers as $adver_id=>$v){
            $cu_id = $v['customer_id'];

            $industry_id = $custIndustryIds[$cu_id] ?? null;
            if($industry_id){
                $adverIndustrys[$adver_id] = $industry_id;
            }
        }

        #快任务直播
        $qtaskLive = JxQtaskLiveOrderDaily::selectRaw('
                advertiser_id,
                sum(cost) as cost,
                sum(item_impression_cnt) as item_impression_cnt,
                sum(item_click_cnt) as item_click_cnt,
                sum(app_download) as app_download,
                sum(conversion_num) as conversion
            ')
            ->where('idate', '>=', $st_date)
            ->where('idate', '<=', $en_date)
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();

        if(!empty($qtaskLive)){
            self::industryQtaskLiveDivide($qtaskLive, $adverIndustrys, $industrys);
        }

        foreach($industrys as &$val){
            #计算值补充
            $val['cost'] = round($val['cost']/1000, 2);
        	$val['ctr'] = $val['item_impression_cnt']>0 ? round($val['item_click_cnt']/$val['item_impression_cnt']*100, 2) : 0;
        	$val['cpc'] = $val['item_click_cnt']>0 ? round($val['cost']/$val['item_click_cnt'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
        }

        if($sort_type){
            array_multisort(array_column($industrys, $sort), SORT_ASC, $industrys);
        } else {
            array_multisort(array_column($industrys, $sort), SORT_DESC, $industrys);
        }

        $offset = ($page-1) * $pageSize;
        $total = count($industrys);
        $industrys = array_slice($industrys, $offset, $pageSize);

        return [$industrys, $total];
    }

    public static function industryQtaskLiveDivide($dataList, $adverIndustrys, &$industrys)
    {
        $columns = [
            'cost',
            'item_impression_cnt',
            'item_click_cnt',
            'app_download',
            'conversion'
        ];

        foreach($dataList as $item){

            $adver_id = $item->advertiser_id;

            $industry_id = $adverIndustrys[$adver_id] ?? null;
            if( !$industry_id ){
                continue;
            }

            if( !isset($industrys[$industry_id]) ){
                continue;
            }

            foreach($columns as $column){
                $industrys[$industry_id][$column] += $item->$column;
            }

        }

        return ;
    }

    /**
     * 获取快任务直播-行业分日数据详情
     */
    public static function industryQtaskLiveDetails($st_date, $en_date, $industry_id, $page, $pageSize)
    {
        #获取客户
        $cust_ids = SysCustomer::where('enable', 1)->where('industry_id', $industry_id)->pluck('id')->all();
        #获取广告主
        $adverCusts = SysCustomerAdver::where('enable', 1)->whereIn('customer_id', $cust_ids)->pluck('customer_id', 'advertiser_id')->all();
        $adver_ids = array_keys($adverCusts);

        $dates = array();
        $th_date = $en_date;
        while($th_date>=$st_date){

            $dates[$th_date] = null;
            $th_date = date('Y-m-d', strtotime($th_date)-86400);
        }

        $qtaskLive = JxQtaskLiveOrderDaily::selectRaw('
                idate,
                advertiser_id,
                sum(cost) as cost,
                sum(item_impression_cnt) as item_impression_cnt,
                sum(item_click_cnt) as item_click_cnt,
                sum(app_download) as app_download,
                sum(conversion_num) as conversion
            ')
            ->where('idate', '>=', $st_date)
            ->where('idate', '<=', $en_date)
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('idate')
            ->groupBy('advertiser_id')
            ->get()
            ->toArray();
        if(!empty($qtaskLive)){
            foreach($qtaskLive as $val){
                $idate = $val['idate'];
                $adver_id = $val['advertiser_id'];

                #获取所属客户
                $cu_id = $adverCusts[$adver_id] ?? null;
                if(!$cu_id){
                    continue;
                }
                if( isset($dates[$idate]) ){
                    $dates[$idate]['cust_ids'][] = $cu_id;
                    $dates[$idate]['cost'] += $val['cost'];
                    $dates[$idate]['item_impression_cnt'] += $val['item_impression_cnt'];
                    $dates[$idate]['item_click_cnt'] += $val['item_click_cnt'];
                    $dates[$idate]['app_download'] += $val['app_download'];
                    $dates[$idate]['conversion'] += $val['conversion'];
                } else {
                    unset($val['advertiser_id']);
                    $val['cust_ids'][] = $cu_id;
                    $dates[$idate] = $val;
                }
            }
        }

        $dates = array_values(array_filter($dates));
        if(!empty($dates)){
            foreach($dates as &$val){
                #计算值补充
                $val['cost'] = round($val['cost']/1000, 2);
	        	$val['ctr'] = $val['item_impression_cnt']>0 ? round($val['item_click_cnt']/$val['item_impression_cnt']*100, 2) : 0;
	        	$val['cpc'] = $val['item_click_cnt']>0 ? round($val['cost']/$val['item_click_cnt'], 2) : null;
	        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
	        	$val['cust_count'] = count($val['cust_ids']);
            }
        }

        $offset = ($page-1) * $pageSize;
        $total = count($dates);
        $dates = array_slice($dates, $offset, $pageSize);

        return [$dates, $total];
    }

    public static function industryQtaskLiveCustDetails($date, $industry_id)
    {
        #获取客户
        $custInfos = SysCustomer::where('enable', 1)->where('industry_id', $industry_id)->pluck('name', 'id')->all();
        $cust_ids = array_keys($custInfos);
        #获取广告主
        $adverCusts = SysCustomerAdver::where('enable', 1)->whereIn('customer_id', $cust_ids)->pluck('customer_id', 'advertiser_id')->all();
        $adver_ids = array_keys($adverCusts);

        $qtaskLive = JxQtaskLiveOrderDaily::selectRaw('
                advertiser_id,
                sum(cost) as cost,
                sum(item_impression_cnt) as item_impression_cnt,
                sum(item_click_cnt) as item_click_cnt,
                sum(app_download) as app_download,
                sum(conversion_num) as conversion
            ')
            ->where('idate', $date)
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('advertiser_id')
            ->get()
            ->toArray();

        $ret = array();
        foreach($qtaskLive as $val) {
            $adver_id = $val['advertiser_id'];
            $cu_id = $adverCusts[$adver_id] ?? null;
            if(!$cu_id){
                continue;
            }

            if(isset($ret[$cu_id])){
                $ret[$cu_id]['cost'] += $val['cost'];
                $ret[$cu_id]['item_impression_cnt'] += $val['item_impression_cnt'];
                $ret[$cu_id]['item_click_cnt'] += $val['item_click_cnt'];
                $ret[$cu_id]['app_download'] += $val['app_download'];
                $ret[$cu_id]['conversion'] += $val['conversion'];
            } else {
                #客户信息
                $val['cust_id'] = $cu_id;
                $val['cust_name'] = $custInfos[$cu_id];
                unset($val['advertiser_id']);
                $ret[$cu_id] = $val;
            }
        }

        foreach($ret as &$val){
            $val['idate'] = $date;
            $val['cost'] = round($val['cost']/1000, 2);
        	$val['ctr'] = $val['item_impression_cnt']>0 ? round($val['item_click_cnt']/$val['item_impression_cnt']*100, 2) : 0;
        	$val['cpc'] = $val['item_click_cnt']>0 ? round($val['cost']/$val['item_click_cnt'], 2) : null;
        	$val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
        }

        return array_values($ret);
    }

    public static function custQtaskVideoList($st_date, $en_date, $sort, $sort_type, $page, $pageSize)
    {
        #查客户信息
        $userInfo = Auth::user();

        $custList = SysCustomer::select('id', 'name', 'industry_id')->whereIn('id', $userInfo->custIds)->where('enable', 1)->get()->keyBy('id')->toArray();

        $_cols = [
            'cost' => 0,
            'view' => 0,
            'play' => 0,
            'action' => 0,
            'admire' => 0,
            'comment' => 0,
            'item_impression_cnt' => 0,
            'item_click_cnt' => 0,
            'play_5s' => 0,
            'play_3s' => 0,
            'app_download' => 0,
            'conversion' => 0,
            'share_num' => 0,
            'ctr' => 0,  //行为率
            'cpm' => 0,  //千次播放成本
            'cpc' => 0,  //点击成本
            'cpa' => 0  //激活成本
        ];

        foreach($custList as &$val){
            $val = array_merge($val, $_cols);
        }

        #查客户广告主关系
        $advers = SysCustomerAdver::select('customer_id', 'advertiser_id')->where('enable', 1)->get()->keyBy('advertiser_id')->toArray();

        #快任务视频
        $qtaskVideo = JxQtaskVideoOrderDaily::selectRaw('
                advertiser_id,
                sum(cost) as cost,
                sum(view) as view,
                sum(play) as play,
                sum(action) as action,
                sum(admire) as admire,
                sum(comment) as comment,
                sum(item_impression_cnt) as item_impression_cnt,
                sum(item_click_cnt) as item_click_cnt,
                sum(play_5s) as play_5s,
                sum(play_3s) as play_3s,
                sum(app_download) as app_download,
                sum(conversion_num) as conversion,
                sum(share_num) as share_num
            ')
            ->where('idate', '>=', $st_date)
            ->where('idate', '<=', $en_date)
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();

        if(!empty($qtaskVideo)){
            self::custQtaskVideoDivide($qtaskVideo, $advers, $custList);
        }

        foreach($custList as &$val){
            #计算值补充
            $val['cost'] = round($val['cost']/1000, 2);
            $val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
            $val['cpm'] = $val['play']>0 ? round($val['cost']/$val['play']*1000, 2) : null;
            $val['cpc'] = $val['action']>0 ? round($val['cost']/$val['action'], 2) : null;
            $val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
        }

        if($sort_type){
            array_multisort(array_column($custList, $sort), SORT_ASC, $custList);
        } else {
            array_multisort(array_column($custList, $sort), SORT_DESC, $custList);
        }

        $offset = ($page-1) * $pageSize;
        $total = count($custList);
        $custList = array_slice($custList, $offset, $pageSize);

        return [$custList, $total];
    }

    public static function custQtaskVideoDivide($dataList, $advers, &$custList)
    {
        $columns = [
            'cost',
            'view',
            'play',
            'action',
            'admire',
            'comment',
            'item_impression_cnt',
            'item_click_cnt',
            'play_5s',
            'play_3s',
            'app_download',
            'conversion',
            'share_num'
        ];

        foreach($dataList as $item){

            $adver_id = $item->advertiser_id;

            $cu_id = $advers[$adver_id]['customer_id'] ?? null;
            if( !$cu_id ){
                continue;
            }

            if( !isset($custList[$cu_id]) ){
                continue;
            }

            foreach($columns as $column){
                $custList[$cu_id][$column] += $item->$column;
            }

        }

        return ;
    }

    /**
     * 获取快任务视频-客户分日数据详情
     */
    public static function custQtaskVideoDetails($st_date, $en_date, $cust_id, $page, $pageSize)
    {
        #获取广告主ids
        $adver_ids = SysCustomerAdver::where('enable', 1)->where('customer_id', $cust_id)->pluck('advertiser_id')->all();

        $qtaskVideo = JxQtaskVideoOrderDaily::selectRaw('
                idate,
                count(distinct(user_id)) as user_count,
                sum(cost) as cost,
                sum(view) as view,
                sum(play) as play,
                sum(action) as action,
                sum(admire) as admire,
                sum(comment) as comment,
                sum(item_impression_cnt) as item_impression_cnt,
                sum(item_click_cnt) as item_click_cnt,
                sum(play_5s) as play_5s,
                sum(play_3s) as play_3s,
                sum(app_download) as app_download,
                sum(conversion_num) as conversion,
                sum(share_num) as share_num
            ')
            ->where('idate', '>=', $st_date)
            ->where('idate', '<=', $en_date)
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('idate')
            ->get()
            ->toArray();

        if(!empty($qtaskVideo)){
            foreach($qtaskVideo as &$val){
              	#计算值补充
                $val['cost'] = round($val['cost']/1000, 2);
                $val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
                $val['cpm'] = $val['play']>0 ? round($val['cost']/$val['play']*1000, 2) : null;
                $val['cpc'] = $val['action']>0 ? round($val['cost']/$val['action'], 2) : null;
                $val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
            }
        }

        $offset = ($page-1) * $pageSize;
        $total = count($qtaskVideo);
        $qtaskVideo = array_slice($qtaskVideo, $offset, $pageSize);

        return [$qtaskVideo, $total];
    }

    public static function custQtaskVideoUserDetails($date, $cust_id)
    {
        #获取广告主ids
        $adver_ids = SysCustomerAdver::where('enable', 1)->where('customer_id', $cust_id)->pluck('advertiser_id')->all();

        $qtaskVideo = JxQtaskVideoOrderDaily::selectRaw('
                user_id,
                any_value(star_name) as star_name,
                any_value(kwai_id) as kwai_id,
                sum(cost) as cost,
                sum(view) as view,
                sum(play) as play,
                sum(action) as action,
                sum(admire) as admire,
                sum(comment) as comment,
                sum(item_impression_cnt) as item_impression_cnt,
                sum(item_click_cnt) as item_click_cnt,
                sum(play_5s) as play_5s,
                sum(play_3s) as play_3s,
                sum(app_download) as app_download,
                sum(conversion_num) as conversion,
                sum(share_num) as share_num
            ')
            ->where('idate', $date)
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('user_id')
            ->get()
            ->toArray();

        foreach($qtaskVideo as &$val){
            $val['idate'] = $date;
            $val['cost'] = round($val['cost']/1000, 2);
            $val['ctr'] = $val['play']>0 ? round($val['action']/$val['play']*100, 2) : 0;
            $val['cpm'] = $val['play']>0 ? round($val['cost']/$val['play']*1000, 2) : null;
            $val['cpc'] = $val['action']>0 ? round($val['cost']/$val['action'], 2) : null;
            $val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
        }

        return $qtaskVideo;
    }

    public static function custQtaskLiveList($st_date, $en_date, $sort, $sort_type, $page, $pageSize)
    {
        #查客户信息
        $userInfo = Auth::user();
        $custList = SysCustomer::select('id', 'name', 'industry_id')->whereIn('id', $userInfo->custIds)->where('enable', 1)->get()->keyBy('id')->toArray();

        $_cols = [
            'cost' => 0,
            'item_impression_cnt' => 0,
            'item_click_cnt' => 0,
            'app_download' => 0,
            'conversion' => 0,
            'ctr' => 0,  //行为率
            'cpc' => 0,  //点击成本
            'cpa' => 0  //激活成本
        ];

        foreach($custList as &$val){
            $val = array_merge($val, $_cols);
        }

        #查客户广告主关系
        $advers = SysCustomerAdver::select('customer_id', 'advertiser_id')->where('enable', 1)->get()->keyBy('advertiser_id')->toArray();

        #快任务直播
        $qtaskLive = JxQtaskLiveOrderDaily::selectRaw('
                advertiser_id,
                sum(cost) as cost,
                sum(item_impression_cnt) as item_impression_cnt,
                sum(item_click_cnt) as item_click_cnt,
                sum(app_download) as app_download,
                sum(conversion_num) as conversion
            ')
            ->where('idate', '>=', $st_date)
            ->where('idate', '<=', $en_date)
            ->where('enable', 1)
            ->groupBy('advertiser_id')
            ->get();

        if(!empty($qtaskLive)){
            self::custQtaskLiveDivide($qtaskLive, $advers, $custList);
        }

        foreach($custList as &$val){
            #计算值补充
            $val['cost'] = round($val['cost']/1000, 2);
            $val['ctr'] = $val['item_impression_cnt']>0 ? round($val['item_click_cnt']/$val['item_impression_cnt']*100, 2) : 0;
            $val['cpc'] = $val['item_click_cnt']>0 ? round($val['cost']/$val['item_click_cnt'], 2) : null;
            $val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
        }

        if($sort_type){
            array_multisort(array_column($custList, $sort), SORT_ASC, $custList);
        } else {
            array_multisort(array_column($custList, $sort), SORT_DESC, $custList);
        }

        $offset = ($page-1) * $pageSize;
        $total = count($custList);
        $custs = array_slice($custList, $offset, $pageSize);

        return [$custs, $total];
    }

    public static function custQtaskLiveDivide($dataList, $advers, &$custList)
    {
        $columns = [
            'cost',
            'item_impression_cnt',
            'item_click_cnt',
            'app_download',
            'conversion'
        ];

        foreach($dataList as $item){

            $adver_id = $item->advertiser_id;

            $cu_id = $advers[$adver_id]['customer_id'] ?? null;
            if( !$cu_id ){
                continue;
            }

            if( !isset($custList[$cu_id]) ){
                continue;
            }

            foreach($columns as $column){
                $custList[$cu_id][$column] += $item->$column;
            }
        }

        return ;
    }

    /**
     * 获取快任务直播-客户分日数据详情
     */
    public static function custQtaskLiveDetails($st_date, $en_date, $cust_id, $page, $pageSize)
    {
        #获取广告主ids
        $adver_ids = SysCustomerAdver::where('enable', 1)->where('customer_id', $cust_id)->pluck('advertiser_id')->all();

        $qtaskLive = JxQtaskLiveOrderDaily::selectRaw('
                idate,
                count(distinct(user_id)) as user_count,
                sum(cost) as cost,
                sum(item_impression_cnt) as item_impression_cnt,
                sum(item_click_cnt) as item_click_cnt,
                sum(app_download) as app_download,
                sum(conversion_num) as conversion
            ')
            ->where('idate', '>=', $st_date)
            ->where('idate', '<=', $en_date)
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('idate')
            ->get()
            ->toArray();
        if(!empty($qtaskLive)){
            foreach($qtaskLive as &$val){
            	#计算值补充
                $val['cost'] = round($val['cost']/1000, 2);
                $val['ctr'] = $val['item_impression_cnt']>0 ? round($val['item_click_cnt']/$val['item_impression_cnt']*100, 2) : 0;
                $val['cpc'] = $val['item_click_cnt']>0 ? round($val['cost']/$val['item_click_cnt'], 2) : null;
                $val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
            }
        }

        $offset = ($page-1) * $pageSize;
        $total = count($qtaskLive);
        $dates = array_slice($qtaskLive, $offset, $pageSize);

        return [$dates, $total];
    }

    public static function custQtaskLiveUserDetails($date, $cust_id)
    {
        #获取广告主ids
        $adver_ids = SysCustomerAdver::where('enable', 1)->where('customer_id', $cust_id)->pluck('advertiser_id')->all();

        $qtaskLive = JxQtaskLiveOrderDaily::selectRaw('
                user_id,
                any_value(star_name) as star_name,
                any_value(kwai_id) as kwai_id,
                sum(cost) as cost,
                sum(item_impression_cnt) as item_impression_cnt,
                sum(item_click_cnt) as item_click_cnt,
                sum(app_download) as app_download,
                sum(conversion_num) as conversion
            ')
            ->where('idate', $date)
            ->where('enable', 1)
            ->whereIn('advertiser_id', $adver_ids)
            ->groupBy('user_id')
            ->get()
            ->toArray();

        foreach($qtaskLive as &$val){
            $val['idate'] = $date;
            $val['cost'] = round($val['cost']/1000, 2);
            $val['ctr'] = $val['item_impression_cnt']>0 ? round($val['item_click_cnt']/$val['item_impression_cnt']*100, 2) : 0;
            $val['cpc'] = $val['item_click_cnt']>0 ? round($val['cost']/$val['item_click_cnt'], 2) : null;
            $val['cpa'] = $val['conversion']>0 ? round($val['cost']/$val['conversion'], 2) : null;
        }

        return $qtaskLive;
    }

    public static function supplementOrderList($custId, $stDate, $enDate, $keyword, $type, $status, $sortField, $sortType, $page, $pageSize)
    {
        $adverIds = [];
        if(!empty($custId)) {
            #获取广告主ids
            $adverIds = SysCustomerAdver::where('enable', 1)->where('customer_id', $custId)->pluck('advertiser_id')->all();
            if(empty($adverIds)) {
                return [[], 0];
            }
        }

        $taskIds = [];
        if(5 == $type) { # 搜索任务名称
            $taskIds = JxStarVideoTaskList::search($keyword);
            if(empty($taskIds)) return [[], 0];
            $taskIds = json_decode(json_encode($taskIds), 1);
        }

        $flowStarVideoQuery = JxStarVideoFlowOrderList::getOrderListQuery($adverIds, $keyword, $type, $status, $taskIds, $stDate, $enDate);

        $count = $flowStarVideoQuery->count();
        $list = $flowStarVideoQuery->selectRaw('advertiser_id, task_id, order_id, supplement_order_id, user_id,
            status, promotion_begin_time, unit_type, unit_price, amount, consume_amount, view, play, action, conversion,
            play_percent, action_percent, ecpm, comment, admire, played3s_percent, target_type, supplement_order_sense_id,
            submissions_number, event_pay
			')->offset(($page - 1) * $pageSize)->limit($pageSize)->orderBy($sortField, $sortType)->get();

        if($list->isEmpty()) {
            return [[], 0];
        }

        # 提取任务ID，然后批量查询任务基础信息(任务名称)
        $taskIdList = array_unique(array_column($list->toArray(), 'task_id'));
        $taskDataList = JxStarVideoTaskList::getTaskDataByIdList($taskIdList);

        foreach($list as $item) {
            $taskData = $taskDataList->where('task_id', $item->task_id)->first();
            # 广告主ID:advertiser_id 聚星订单ID:order_id 任务ID:task_id 达人ID:user_id 推广状态:status 推广开始时间:promotion_begin_time
            # 优化目标:unit_type 封面曝光数:view 封面点击数:play 投放人群:target_type 助推订单ID:supplement_order_id
            # 评论数:comment 点赞数:admire 行为数(在视频点击广告的次数):action 激活数:conversion 推广广告位:supplement_order_sense_id
            # 表单提交数:submissions_number

            # 封面
            # 计费方式 OCPM
            # 投放位置 全域
            # 系统定向 不限
            # 素材曝光数（双列为封面点击数/单列为播放量）
            # 互动数（视频的点赞，评论，分享，关注按钮总点击数）
            # 互动成本=总消耗/互动数

            $item->order_id = strval($item->order_id);
            $item->task_id = strval($item->task_id);
            $item->supplement_order_id = strval($item->supplement_order_id);
            $item->user_id = strval($item->user_id);
            $item->task_name = $taskData->task_name ?? ''; # 任务名称
            $item->unit_price = !empty($item->unit_price) ? round($item->unit_price/1000, 2) : 0; # 出价/目标成本
            $item->promotion_days = $taskData->promotion_days ?? ''; # 投放时长
            $item->amount = !empty($item->amount) ? round($item->amount/1000, 2) : 0; # 冻结金额
            $item->consume_amount = !empty($item->consume_amount) ? round($item->consume_amount/1000, 2) : 0; # 实际消耗金额
            $item->ecpm = !empty($item->ecpm) ? round($item->ecpm/1000, 2) : 0; # 平均千次素材曝光花费 = 实际消耗金额/素材曝光数*1000
            # 行为成本 = 实际消耗金额 / 行为数
            $item->action_cost = ($item->action > 0) ? round($item->consume_amount / $item->action, 2) : 0;
            # 激活单价 = 实际消耗金额 / 激活数
            $item->conversion_cost = ($item->conversion > 0) ? round($item->consume_amount / $item->conversion, 2) : 0;
            # 行为率 = 行为数 / 素材曝光数:action_percent
            $item->action_percent = !empty($item->action_percent) ? round($item->action_percent * 100, 2).'%' : '0%';
            # 3s播放率 = 视频播放至3s的播放数 / 视频播放数:played3s_percent
            $item->played3s_percent = !empty($item->played3s_percent) ? round($item->played3s_percent * 100, 2).'%' : '0%';
            # 封面点击率 = 封面点击数 / 封面曝光数:play_percent
            $item->play_percent = !empty($item->play_percent) ? round($item->play_percent * 100, 2).'%' : '0%';
        }

        return [$list, $count];
    }

    # 小时数据趋势
    public static function svfHourDataCure($custId, $startTime, $endTime) {
        $adverIds = [];
        if(!empty($custId)) {
            #获取广告主ids
            $adverIds = SysCustomerAdver::where('enable', 1)->where('customer_id', $custId)->pluck('advertiser_id')->all();
        }

        $data = [];
        $star = $startTime;
        while($star <= $endTime) {
            $data[] = [
                'consume_amount' => 0,
                'cpm' => 0,
                'cpc' => 0,
                'cpa' => 0,
                'sub_cpa' => 0,
                'hour' => date("m-d H:00", strtotime($star)),
//                'date' => date("Y-m-d", strtotime($star)),
                'date_time' => $star
            ];

            $star = date('Y-m-d H:00:00', strtotime($star.' +1 hour'));
        }

        # 筛选出符合条件的记录
        $list = JxStarVideoFlowOrderHourData::getHourData($adverIds, $startTime, $endTime);

        foreach($data as $key=>$value) {
            $dateTime = $value['date_time'];
            $hourInfo = $list[$dateTime] ?? [];
            if(!empty($hourInfo)) {
                $consumeAmount = round($hourInfo['consume_amount']/1000, 2);
                if($dateTime < '2024-07-05 00:00:00'){ # 首次开始处理数据的时间，因为前一个小时的数据没有，趋势图会显得很突兀
                    $consumeAmount = 0;
                }
                $data[$key]['consume_amount'] = $consumeAmount;
                $data[$key]['cpm'] = $hourInfo['play']>0 ? round($consumeAmount/$hourInfo['play']*1000, 2) : 0;
                $data[$key]['cpc'] = $hourInfo['action']>0 ? round($consumeAmount/$hourInfo['action'], 2) : 0;
                $data[$key]['cpa'] = $hourInfo['conversion']>0 ? round($consumeAmount/$hourInfo['conversion'], 2) : 0;
                $data[$key]['sub_cpa'] = $hourInfo['submissions_number']>0 ? round($consumeAmount/$hourInfo['submissions_number'], 2) : 0;
            }
        }

        return $data;
    }

    # 小时数据对比
    public static function svfHourDataContrast($custId, $period) {
        $adverIds = [];
        if(!empty($custId)) {
            #获取广告主ids
            $adverIds = SysCustomerAdver::where('enable', 1)->where('customer_id', $custId)->pluck('advertiser_id')->all();
        }

        $dateList = $data = [];
        # 遍历对比时段,整理需要处理的日期
        $period = !is_array($period) ? json_decode($period, 1) : $period;
        foreach($period as $timeArr) {
            $date = $timeArr['start_date'];
            while($date <= $timeArr['end_date']){
                $dateList[] = $date;
                $date = date("Y-m-d", strtotime($date.' +1 day'));
            }
        }

        # 对需要查询的日期列表去重排序
        $unqDateList = array_unique($dateList);
        sort($unqDateList);

        # 整理所有需要处理的小时数据
        $timeList = $dateTimeList = [];
        foreach ($unqDateList as $date) {
            $startTime = $date . ' 00:00:00';
            $hourList = [];
            for($i = 0; $i < 24; $i++) {
                $time = date('Y-m-d H:00:00', strtotime($startTime.' +'.$i.' hours'));
                $hour = date('H', strtotime($startTime.' +'.$i.' hours'));
                $timeList[] = $time;
                $hourList[] = [
                    "hour" => $hour,
                    "consume_amount" => 0,
                    "cpm" => 0,
                    "cpc" => 0,
                    "cpa" => 0,
                    "sub_cpa" => 0
                ];
            }

            $dateTimeList[] = [
                "date" => $date,
                "hour_list" => $hourList
            ];
        }

        # 批量查询小时数据
        $list = JxStarVideoFlowOrderHourData::getDataByHourList($adverIds, $timeList);

        foreach($dateTimeList as $key => $dateVal) {
            $date = $dateVal['date'];
            $hourList = $dateVal['hour_list'];
            foreach($hourList as $hour=>$val) {
                $dateTime = date("Y-m-d H:i:s", strtotime($date.' '.$hour.':00:00'));
                $hourInfo = $list[$dateTime] ?? [];
                if(!empty($hourInfo)) {
                    $consumeAmount = round($hourInfo['consume_amount']/1000, 2);
                    if($dateTime < '2024-07-05 00:00:00'){ # 首次开始处理数据的时间，因为前一个小时的数据没有，趋势图会显得很突兀
                        $consumeAmount = 0;
                    }
                    $dateTimeList[$key]['hour_list'][$hour]['consume_amount'] = $consumeAmount;
                    $dateTimeList[$key]['hour_list'][$hour]['cpm'] = $hourInfo['play']>0 ? round($consumeAmount/$hourInfo['play']*1000, 2) : 0;
                    $dateTimeList[$key]['hour_list'][$hour]['cpc'] = $hourInfo['action']>0 ? round($consumeAmount/$hourInfo['action'], 2) : 0;
                    $dateTimeList[$key]['hour_list'][$hour]['cpa'] = $hourInfo['conversion']>0 ? round($consumeAmount/$hourInfo['conversion'], 2) : 0;
                    $dateTimeList[$key]['hour_list'][$hour]['sub_cpa'] = $hourInfo['submissions_number']>0 ? round($consumeAmount/$hourInfo['submissions_number'], 2) : 0;
                }
            }
        }

        return $dateTimeList;
    }
}
