<?php

namespace App\Support;

class Error
{
    /**
     * 错误码
     * @var [type]
     */
    public static $errCodes = [
        0 => '操作成功！',
        10 => '操作失败！',
        100 => '请求传递参数有误！',
        400 => '请求失败，请稍候再试！',
        401 => '登录验证失败',
        403 => '登录失效',
        500 => '未知错误，请联系管理员！',
        501 => '请求第三方平台数据失败，请联系管理员',
        1102 => "参数错误, 请确认无误后重试", //接口所传参数验证失败

        2001 => '密码至少六位',
        2002 => '登录账号不存在',
        2003 => '登录账号或密码不正确',

        4002 => '登录失败，请重新登录',

        1000 => '该账号信息不存在',

        # 1050 - 1059 客户操作
        1050 => '客户名称存在重复',
        1051 => '该客户信息不存在',
        1052 => '该客户下存在正在使用的账号，不可被删除',

        # 1060 - 1169 客户操作
        1060 => '字段配置详情不存在',
        1061 => '该上传文件无效',
        1062 => '暂不支持该上传文件类型',

        # 1070 - 1079 组操作
        1070 => '用户组已存在',
        1071 => '该编辑的用户组信息不存在',

        1080 => '未检测到有可操作的广告账户',
        1081 => '此配置不存在，无法编辑',
        1082 => '配置已开始创建助推订单，无法编辑',
        1083 => '配置失败，请重试',
        1084 => '禁用失败，请重试',

        1200 => '操作过于频繁，请一分钟后再次尝试',

        1300 => '今天已参与过抽奖，请明天再来吧',
        1301 => '该手机号已领过奖品',


    ];
    /**
     * 返回错误码
     * @var string
     */
    public static function getError($code = "400", $_ = false)
    {
        if (! isset(self::$errCodes[$code])) {
            $code = "400";
        }
        return ($_ ? "[{$code}]" : "")
            . self::$errCodes[$code];
    }
}
