<?php

namespace kwaiSDK\Api\JinNiu;

use kwaiSDK\Api\Request;

class Creative extends Request
{
    /**
     * 创建创意
     * @param array $data
     * @return mixed
     */
    public function create(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/creative/create';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 修改创意
     * @param array $data
     * @return mixed
     */
    public function update(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/creative/update';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 修改创意状态
     * @param array $data
     * @return mixed
     */
    public function updateStatus(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/creative/update/status';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 获取可选的推荐封面
     * @param array $data
     * @return mixed
     */
    public function helperKeyFrame(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/creative/helper/keyFrame';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 获取可选的动态词包
     * @param array $data
     * @return mixed
     */
    public function helperListBagWords(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/creative/helper/list/bagWords';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 获取行动号召按钮
     * @param array $data
     * @return mixed
     */
    public function helperListActionBarText(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/creative/helper/list/actionBarText';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 创建程序化 2.0 创意
     * @param array $data
     * @return mixed
     */
    public function advancedProgramCreate(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/creative/advanced/program/create';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 编辑程序化 2.0 创意
     * @param array $data
     * @return mixed
     */
    public function advancedProgramUpdate(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/creative/advanced/program/update';
        $this->data = $data;

        return $this->exec();
    }
}
