<?php

namespace kwaiSDK\Api\JuXing;

use kwaiSDK\Api\Request;

class InvestData extends Request
{
    /**
     * 查询星视频订单的投后数据
     * @param array $data
     * @return mixed
     */
    public function taskList(array $data=[])
    {
        $this->apiPre  = '/rest/openapi/v1/ad_social';
        $this->type    = 'POST';
        $this->path    = '/task/list';
        $this->data    = $data;

        return $this->exec();
    }

    /**
     * 星直播任务列表接口
     * @param array $data
     * @return mixed
     */
    public function starLiveTaskList(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/v1/star/live/task/list';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 星直播订单列表接口
     * @param array $data
     * @return mixed
     */
    public function starLiveOrderList(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/v1/star/live/order/list';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 快任务任务列表接口
     * @param array $data
     * @return mixed
     */
    public function quickTaskTaskList(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/v1/quick_task/task/list';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 快任务订单列表接口
     * @param array $data
     * @return mixed
     */
    public function quickTaskOrderList(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/v1/quick_task/order/list';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 快任务订单分天接口
     * @param array $data
     * @return mixed
     */
    public function quickTaskOrderDaily(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/v1/quick_task/video/order/daily_data';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 快任务直播任务列表接口
     * @param array $data
     * @return mixed
     */
    public function quickTaskLiveTaskList(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/v1/quick_task/live/task/list';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 快任务直播订单列表接口
     * @param array $data
     * @return mixed
     */
    public function quickTaskLiveOrderList(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/v1/quick_task/live/order/list';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 快任务直播订单分天接口
     * @param array $data
     * @return mixed
     */
    public function quickTaskLiveOrderDaily(array $data=[])
    {
        $this->type = 'POST';
        $this->path = '/v1/quick_task/live/order/daily_data';
        $this->data = $data;

        return $this->exec();
    }

    /**
     * 查询流量助推订单的投后数据
     * @param array $data
     * @return mixed
     */
    public function supplementOrderList(array $data=[])
    {
        $this->apiPre  = '/rest/openapi/v1/ad_social';
        $this->type    = 'POST';
        $this->path    = '/supplement_order/list';
        $this->data    = $data;

        return $this->exec();
    }
}
