<?php


namespace kwaiSDK\Api\JuXing;


use kwaiSDK\Api\Request;

class ThirdData extends Request
{
    /**
     * 近期视频作品
     * @param array $data
     * @return mixed
     */
    public function recentVideoList(array $data=[])
    {
        $this->type    = 'POST';
        $this->path    = '/v1/third_data/recent_video/list';
        $this->data    = $data;

        return $this->exec();
    }

    /**
     * 店铺商品数据
     * @param array $data
     * @return mixed
     */
    public function shopProductList(array $data=[])
    {
        $this->type    = 'POST';
        $this->path    = '/v1/third_data/shop_product/list';
        $this->data    = $data;

        return $this->exec();
    }

    /**
     * 达人ID列表
     * @param array $data
     * @return mixed
     */
    public function userIdList(array $data=[])
    {
        $this->type    = 'POST';
        $this->path    = '/v1/third_data/user_id/list';
        $this->data    = $data;

        return $this->exec();
    }

    /**
     * 达人基础信息
     * @param array $data
     * @return mixed
     */
    public function starInfoDetail(array $data=[])
    {
        $this->type    = 'POST';
        $this->path    = '/v1/third_data/star_info/detail';
        $this->data    = $data;

        return $this->exec();
    }

    /**
     * 正在直播数据
     * @param array $data
     * @return mixed
     */
    public function liveInfoList(array $data=[])
    {
        $this->type    = 'POST';
        $this->path    = '/v1/third_data/live_info/list';
        $this->data    = $data;

        return $this->exec();
    }

    /**
     * 历史直播数据
     * @param array $data
     * @return mixed
     */
    public function historyLiveInfoList(array $data=[])
    {
        $this->type    = 'POST';
        $this->path    = '/v1/third_data/history_live_info/list';
        $this->data    = $data;

        return $this->exec();
    }

    /**
     * 用户ID加密
     * @param array $data
     * @return mixed
     */
    public function encryptUserId(array $data=[])
    {
        $this->type    = 'POST';
        $this->path    = '/v1/third_data/encrypt_user_id';
        $this->data    = $data;

        return $this->exec();
    }
}
