<?php

namespace kwaiSDK;

use kwaiSDK\Api\JuXing\InvestData;
use kwaiSDK\Api\JuXing\SupplementOrderV1;
use kwaiSDK\Api\JuXing\SupplementOrderV2;
use kwaiSDK\Api\JuXing\ThirdData;
use kwaiSDK\Api\JuXing\Transaction;

class JuXing
{
    protected $accessToken;
    protected $host;

    protected $options = [];

    function __construct($accessToken='', $host='https://ad.e.kuaishou.com'){
        $this->accessToken = $accessToken;
        $this->host        = $host;
    }

    /**
     * 初始化
     * */
    private function init(){
        return [
            'access_token' => $this->accessToken,
            'host'         => $this->host,
            'options'      => $this->options,
            'api_pre'      => '/rest/openapi/gw/ad_social'

        ];
    }

    /**
     *  设置
     * */
    function setOptions(array $options=[]){
        $this->options = $options;
    }

    /**
     * 投后数据相关
     * */
    public function investData(){
        return  new InvestData($this->init());
    }

    /**
     * 聚星mapi下单
     * */
    public function transaction(){
        return  new Transaction($this->init());
    }

    /**
     * 流量助推1.0
     * */
    public function supplementOrderV1(){
        return  new SupplementOrderV1($this->init());
    }

    /**
     * 流量助推2.0
     * */
    public function supplementOrderV2(){
        return  new SupplementOrderV2($this->init());
    }

    /**
     * 第三方接口
     * */
    public function thirdData(){
        return new ThirdData($this->init());
    }
}
